/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 1 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:339  */

#if USE_WINDOWS
#pragma warning(push,1)
#pragma warning(disable:4702) // unreachable code
#endif
#line 161 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:339  */


// some helpers
#include <float.h> // for FLT_MAX

static void AddInsval ( SqlParser_c * pParser, CSphVector<SqlInsert_t> & dVec, const SqlNode_t & tNode )
{
	SqlInsert_t & tIns = dVec.Add();
	tIns.m_iType = tNode.m_iType;
	tIns.m_iVal = tNode.m_iValue; // OPTIMIZE? copy conditionally based on type?
	tIns.m_fVal = tNode.m_fValue;
	if ( tIns.m_iType==TOK_QUOTED_STRING )
		pParser->ToStringUnescape ( tIns.m_sVal, tNode );
	tIns.m_pVals = tNode.m_pValues;
}

static CSphFilterSettings * AddMvaRange ( SqlParser_c * pParser, const SqlNode_t & tNode, int64_t iMin, int64_t iMax )
{
	CSphFilterSettings * f = pParser->AddFilter ( tNode, SPH_FILTER_RANGE );
	f->m_eMvaFunc = ( tNode.m_iType==TOK_ALL ) ? SPH_MVAFUNC_ALL : SPH_MVAFUNC_ANY;
	f->m_iMinValue = iMin;
	f->m_iMaxValue = iMax;
	return f;
}

#define TRACK_BOUNDS(_res,_left,_right) \
	_res = _left; \
	if ( _res.m_iStart>0 && pParser->m_pBuf[_res.m_iStart-1]=='`' ) \
		_res.m_iStart--; \
	_res.m_iEnd = _right.m_iEnd; \
	_res.m_iType = 0;


#line 106 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* In a future release of Bison, this section will be replaced
   by #include "bissphinxql.h".  */
#ifndef YY_YY_HOME_GITLAB_RUNNER_BUILDS_AE04CF72_0_MANTICORESEARCH_DEV_BUILD_CONFIG_BISSPHINXQL_H_INCLUDED
# define YY_YY_HOME_GITLAB_RUNNER_BUILDS_AE04CF72_0_MANTICORESEARCH_DEV_BUILD_CONFIG_BISSPHINXQL_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    TOK_IDENT = 258,
    TOK_ATIDENT = 259,
    TOK_CONST_INT = 260,
    TOK_CONST_FLOAT = 261,
    TOK_CONST_MVA = 262,
    TOK_QUOTED_STRING = 263,
    TOK_USERVAR = 264,
    TOK_SYSVAR = 265,
    TOK_CONST_STRINGS = 266,
    TOK_BAD_NUMERIC = 267,
    TOK_SUBKEY = 268,
    TOK_DOT_NUMBER = 269,
    TOK_ADD = 270,
    TOK_AGENT = 271,
    TOK_ALTER = 272,
    TOK_ALL = 273,
    TOK_ANY = 274,
    TOK_AS = 275,
    TOK_ASC = 276,
    TOK_ATTACH = 277,
    TOK_ATTRIBUTES = 278,
    TOK_AVG = 279,
    TOK_BEGIN = 280,
    TOK_BETWEEN = 281,
    TOK_BIGINT = 282,
    TOK_BOOL = 283,
    TOK_BY = 284,
    TOK_CALL = 285,
    TOK_CHARACTER = 286,
    TOK_CHUNK = 287,
    TOK_CLUSTER = 288,
    TOK_COLLATE = 289,
    TOK_COLLATION = 290,
    TOK_COLUMN = 291,
    TOK_COMMIT = 292,
    TOK_COMMITTED = 293,
    TOK_COUNT = 294,
    TOK_CREATE = 295,
    TOK_DATABASES = 296,
    TOK_DEBUG = 297,
    TOK_DELETE = 298,
    TOK_DESC = 299,
    TOK_DESCRIBE = 300,
    TOK_DISTINCT = 301,
    TOK_DIV = 302,
    TOK_DOUBLE = 303,
    TOK_DROP = 304,
    TOK_FACET = 305,
    TOK_FALSE = 306,
    TOK_FLOAT = 307,
    TOK_FLUSH = 308,
    TOK_FOR = 309,
    TOK_FROM = 310,
    TOK_FUNCTION = 311,
    TOK_GLOBAL = 312,
    TOK_GROUP = 313,
    TOK_GROUPBY = 314,
    TOK_GROUP_CONCAT = 315,
    TOK_HAVING = 316,
    TOK_HOSTNAMES = 317,
    TOK_ID = 318,
    TOK_IN = 319,
    TOK_INDEX = 320,
    TOK_INDEXES = 321,
    TOK_INDEXOF = 322,
    TOK_INSERT = 323,
    TOK_INT = 324,
    TOK_INTEGER = 325,
    TOK_INTO = 326,
    TOK_IS = 327,
    TOK_ISOLATION = 328,
    TOK_JOIN = 329,
    TOK_JSON = 330,
    TOK_LEVEL = 331,
    TOK_LIKE = 332,
    TOK_LIMIT = 333,
    TOK_LOGS = 334,
    TOK_MATCH = 335,
    TOK_MAX = 336,
    TOK_META = 337,
    TOK_MIN = 338,
    TOK_MOD = 339,
    TOK_MULTI = 340,
    TOK_MULTI64 = 341,
    TOK_NAMES = 342,
    TOK_NULL = 343,
    TOK_OPTION = 344,
    TOK_ORDER = 345,
    TOK_OPTIMIZE = 346,
    TOK_PLAN = 347,
    TOK_PLUGIN = 348,
    TOK_PLUGINS = 349,
    TOK_PROFILE = 350,
    TOK_RAND = 351,
    TOK_RAMCHUNK = 352,
    TOK_READ = 353,
    TOK_REGEX = 354,
    TOK_RECONFIGURE = 355,
    TOK_RELOAD = 356,
    TOK_REPEATABLE = 357,
    TOK_REPLACE = 358,
    TOK_REMAP = 359,
    TOK_RETURNS = 360,
    TOK_ROLLBACK = 361,
    TOK_RTINDEX = 362,
    TOK_SELECT = 363,
    TOK_SERIALIZABLE = 364,
    TOK_SET = 365,
    TOK_SETTINGS = 366,
    TOK_SESSION = 367,
    TOK_SHOW = 368,
    TOK_SONAME = 369,
    TOK_START = 370,
    TOK_STATUS = 371,
    TOK_STRING = 372,
    TOK_SYSFILTERS = 373,
    TOK_SUM = 374,
    TOK_TABLE = 375,
    TOK_TABLES = 376,
    TOK_THREADS = 377,
    TOK_TO = 378,
    TOK_TRANSACTION = 379,
    TOK_TRUE = 380,
    TOK_TRUNCATE = 381,
    TOK_TYPE = 382,
    TOK_UNCOMMITTED = 383,
    TOK_UPDATE = 384,
    TOK_VALUES = 385,
    TOK_VARIABLES = 386,
    TOK_WAITTIMEOUT = 387,
    TOK_WARNINGS = 388,
    TOK_WEIGHT = 389,
    TOK_WHERE = 390,
    TOK_WITH = 391,
    TOK_WITHIN = 392,
    TOK_OR = 393,
    TOK_AND = 394,
    TOK_NE = 395,
    TOK_LTE = 396,
    TOK_GTE = 397,
    TOK_NOT = 398,
    TOK_NEG = 399
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif



int yyparse (SqlParser_c * pParser);

#endif /* !YY_YY_HOME_GITLAB_RUNNER_BUILDS_AE04CF72_0_MANTICORESEARCH_DEV_BUILD_CONFIG_BISSPHINXQL_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 301 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  301
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   6225

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  163
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  157
/* YYNRULES -- Number of rules.  */
#define YYNRULES  565
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1014

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   399

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   152,   141,     2,
     156,   157,   150,   148,   158,   149,     2,   151,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   155,
     144,   142,   145,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   161,     2,   162,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   159,   140,   160,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   143,   146,   147,   153,   154
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   198,   198,   199,   200,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   254,   255,   255,   255,   255,   255,   255,   255,   255,
     256,   256,   256,   256,   256,   256,   257,   257,   257,   257,
     257,   257,   258,   258,   258,   258,   258,   259,   259,   259,
     259,   259,   260,   260,   260,   260,   260,   260,   261,   261,
     261,   261,   261,   261,   261,   262,   262,   262,   262,   262,
     262,   263,   263,   263,   263,   263,   263,   264,   264,   264,
     264,   264,   265,   265,   265,   265,   265,   266,   266,   266,
     266,   266,   267,   267,   267,   267,   267,   268,   268,   268,
     268,   268,   268,   269,   269,   269,   269,   269,   269,   270,
     270,   270,   270,   270,   271,   271,   271,   271,   271,   275,
     275,   275,   275,   281,   282,   283,   287,   288,   289,   293,
     294,   302,   303,   310,   312,   316,   320,   327,   328,   329,
     333,   346,   353,   355,   360,   369,   385,   386,   390,   391,
     394,   396,   397,   401,   402,   403,   404,   405,   406,   407,
     408,   409,   413,   414,   417,   419,   423,   427,   428,   429,
     430,   431,   435,   443,   444,   445,   446,   451,   458,   466,
     474,   483,   488,   493,   498,   503,   508,   513,   518,   523,
     528,   533,   538,   543,   548,   553,   558,   563,   568,   573,
     578,   583,   588,   593,   598,   603,   608,   613,   618,   625,
     635,   641,   652,   659,   668,   672,   681,   685,   689,   693,
     697,   707,   708,   713,   719,   725,   731,   737,   738,   739,
     740,   741,   745,   746,   750,   751,   762,   763,   764,   768,
     774,   781,   787,   793,   795,   798,   800,   807,   811,   817,
     819,   825,   827,   831,   842,   844,   848,   852,   859,   860,
     864,   865,   866,   869,   871,   875,   879,   885,   887,   891,
     895,   896,   900,   905,   910,   915,   921,   926,   934,   939,
     946,   956,   957,   958,   959,   960,   961,   962,   963,   964,
     966,   967,   968,   969,   970,   971,   972,   973,   974,   975,
     976,   977,   978,   979,   980,   981,   982,   983,   984,   985,
     986,   987,   988,   989,   993,   994,   995,   996,   997,   998,
     999,  1000,  1001,  1002,  1003,  1004,  1005,  1006,  1007,  1008,
    1012,  1013,  1017,  1018,  1022,  1023,  1024,  1028,  1029,  1033,
    1034,  1038,  1039,  1045,  1048,  1050,  1054,  1055,  1056,  1057,
    1058,  1059,  1060,  1061,  1062,  1067,  1072,  1077,  1082,  1088,
    1096,  1097,  1100,  1102,  1110,  1115,  1120,  1125,  1126,  1127,
    1128,  1132,  1137,  1142,  1147,  1153,  1160,  1170,  1171,  1175,
    1176,  1177,  1189,  1190,  1194,  1195,  1196,  1197,  1198,  1205,
    1206,  1207,  1211,  1212,  1218,  1226,  1227,  1230,  1232,  1236,
    1237,  1241,  1242,  1246,  1247,  1251,  1255,  1256,  1260,  1261,
    1262,  1263,  1264,  1267,  1268,  1272,  1273,  1277,  1283,  1293,
    1301,  1305,  1312,  1313,  1320,  1330,  1336,  1338,  1342,  1347,
    1351,  1358,  1360,  1364,  1365,  1371,  1378,  1380,  1386,  1387,
    1393,  1397,  1403,  1411,  1412,  1416,  1430,  1436,  1440,  1445,
    1459,  1470,  1471,  1472,  1473,  1474,  1475,  1476,  1477,  1478,
    1482,  1490,  1497,  1503,  1510,  1522,  1526,  1533,  1534,  1538,
    1542,  1543,  1547,  1551,  1558,  1565,  1571,  1572,  1573,  1577,
    1578,  1579,  1580,  1586,  1597,  1598,  1599,  1600,  1601,  1606,
    1617,  1626,  1628,  1637,  1646,  1655,  1663,  1671,  1681,  1689,
    1690,  1694,  1698,  1702,  1712,  1720,  1722,  1731,  1742,  1753,
    1763,  1774,  1775,  1779,  1782,  1783,  1787,  1788,  1789,  1790,
    1794,  1795,  1799,  1804,  1806,  1810,  1819,  1823,  1831,  1832,
    1836,  1847,  1849,  1856,  1864,  1872,  1880,  1885,  1887,  1891,
    1896,  1903,  1911,  1913,  1917,  1926
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_IDENT", "TOK_ATIDENT",
  "TOK_CONST_INT", "TOK_CONST_FLOAT", "TOK_CONST_MVA", "TOK_QUOTED_STRING",
  "TOK_USERVAR", "TOK_SYSVAR", "TOK_CONST_STRINGS", "TOK_BAD_NUMERIC",
  "TOK_SUBKEY", "TOK_DOT_NUMBER", "TOK_ADD", "TOK_AGENT", "TOK_ALTER",
  "TOK_ALL", "TOK_ANY", "TOK_AS", "TOK_ASC", "TOK_ATTACH",
  "TOK_ATTRIBUTES", "TOK_AVG", "TOK_BEGIN", "TOK_BETWEEN", "TOK_BIGINT",
  "TOK_BOOL", "TOK_BY", "TOK_CALL", "TOK_CHARACTER", "TOK_CHUNK",
  "TOK_CLUSTER", "TOK_COLLATE", "TOK_COLLATION", "TOK_COLUMN",
  "TOK_COMMIT", "TOK_COMMITTED", "TOK_COUNT", "TOK_CREATE",
  "TOK_DATABASES", "TOK_DEBUG", "TOK_DELETE", "TOK_DESC", "TOK_DESCRIBE",
  "TOK_DISTINCT", "TOK_DIV", "TOK_DOUBLE", "TOK_DROP", "TOK_FACET",
  "TOK_FALSE", "TOK_FLOAT", "TOK_FLUSH", "TOK_FOR", "TOK_FROM",
  "TOK_FUNCTION", "TOK_GLOBAL", "TOK_GROUP", "TOK_GROUPBY",
  "TOK_GROUP_CONCAT", "TOK_HAVING", "TOK_HOSTNAMES", "TOK_ID", "TOK_IN",
  "TOK_INDEX", "TOK_INDEXES", "TOK_INDEXOF", "TOK_INSERT", "TOK_INT",
  "TOK_INTEGER", "TOK_INTO", "TOK_IS", "TOK_ISOLATION", "TOK_JOIN",
  "TOK_JSON", "TOK_LEVEL", "TOK_LIKE", "TOK_LIMIT", "TOK_LOGS",
  "TOK_MATCH", "TOK_MAX", "TOK_META", "TOK_MIN", "TOK_MOD", "TOK_MULTI",
  "TOK_MULTI64", "TOK_NAMES", "TOK_NULL", "TOK_OPTION", "TOK_ORDER",
  "TOK_OPTIMIZE", "TOK_PLAN", "TOK_PLUGIN", "TOK_PLUGINS", "TOK_PROFILE",
  "TOK_RAND", "TOK_RAMCHUNK", "TOK_READ", "TOK_REGEX", "TOK_RECONFIGURE",
  "TOK_RELOAD", "TOK_REPEATABLE", "TOK_REPLACE", "TOK_REMAP",
  "TOK_RETURNS", "TOK_ROLLBACK", "TOK_RTINDEX", "TOK_SELECT",
  "TOK_SERIALIZABLE", "TOK_SET", "TOK_SETTINGS", "TOK_SESSION", "TOK_SHOW",
  "TOK_SONAME", "TOK_START", "TOK_STATUS", "TOK_STRING", "TOK_SYSFILTERS",
  "TOK_SUM", "TOK_TABLE", "TOK_TABLES", "TOK_THREADS", "TOK_TO",
  "TOK_TRANSACTION", "TOK_TRUE", "TOK_TRUNCATE", "TOK_TYPE",
  "TOK_UNCOMMITTED", "TOK_UPDATE", "TOK_VALUES", "TOK_VARIABLES",
  "TOK_WAITTIMEOUT", "TOK_WARNINGS", "TOK_WEIGHT", "TOK_WHERE", "TOK_WITH",
  "TOK_WITHIN", "TOK_OR", "TOK_AND", "'|'", "'&'", "'='", "TOK_NE", "'<'",
  "'>'", "TOK_LTE", "TOK_GTE", "'+'", "'-'", "'*'", "'/'", "'%'",
  "TOK_NOT", "TOK_NEG", "';'", "'('", "')'", "','", "'{'", "'}'", "'['",
  "']'", "$accept", "request", "statement", "ident_set", "ident",
  "multi_stmt_list", "multi_stmt", "select", "select1",
  "opt_tablefunc_args", "tablefunc_args_list", "tablefunc_arg",
  "subselect_start", "opt_outer_order", "opt_outer_limit", "select_from",
  "select_items_list", "select_item", "opt_alias", "select_expr",
  "ident_list", "opt_where_clause", "where_clause", "where_expr",
  "where_item", "filter_expr", "filter_item", "expr_ident", "mva_aggr",
  "const_int", "const_float", "const_list", "string_list",
  "opt_group_clause", "opt_int", "group_items_list", "opt_having_clause",
  "opt_group_order_clause", "group_order_clause", "opt_order_clause",
  "order_clause", "order_items_list", "order_item", "opt_limit_clause",
  "limit_clause", "opt_option_clause", "option_clause", "option_list",
  "option_item", "named_const_list", "named_const", "expr", "function",
  "arglist", "arg", "json_aggr", "consthash", "hash_key", "hash_val",
  "show_stmt", "like_filter", "show_what", "index_or_table", "opt_chunk",
  "set_stmt", "set_global_stmt", "set_string_value", "boolean_value",
  "set_value", "simple_set_value", "transact_op", "start_transaction",
  "insert_into", "insert_or_replace", "opt_column_list", "column_ident",
  "column_list", "insert_rows_list", "insert_row", "insert_vals_list",
  "insert_val", "opt_insert_options", "insert_options_list",
  "insert_option", "delete_from", "call_proc", "call_args_list",
  "call_arg", "const_string_list", "opt_call_opts_list", "call_opts_list",
  "call_opt", "opt_as", "call_opt_name", "describe", "describe_opt",
  "describe_tok", "show_tables", "show_databases", "update",
  "update_items_list", "update_item", "alter_col_type", "alter",
  "show_variables", "opt_show_variables_where", "show_variables_where",
  "show_variables_where_list", "show_variables_where_entry",
  "show_collation", "show_character_set", "set_transaction", "opt_scope",
  "isolation_level", "create_function", "udf_type", "drop_function",
  "attach_index", "opt_with_truncate", "flush_rtindex", "flush_ramchunk",
  "flush_index", "flush_hostnames", "flush_logs", "select_sysvar",
  "sysvar_list", "sysvar_item", "sysvar_name", "select_dual", "truncate",
  "opt_with_reconfigure", "optimize_index", "create_plugin", "drop_plugin",
  "reload_plugins", "json_field", "json_expr", "subscript", "subkey",
  "streq", "strval", "opt_facet_by_items_list", "facet_by", "facet_item",
  "facet_expr", "facet_items_list", "facet_stmt", "opt_reload_index_from",
  "reload_index", "reload_indexes", "sysfilters", "debug_clause",
  "opt_par", "join_cluster", "cluster_opts_list", "create_cluster",
  "delete_cluster", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     124,    38,    61,   395,    60,    62,   396,   397,    43,    45,
      42,    47,    37,   398,   399,    59,    40,    41,    44,   123,
     125,    91,    93
};
# endif

#define YYPACT_NINF -770

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-770)))

#define YYTABLE_NINF -543

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    5696,    26,    23,  -770,  5040,  -770,    34,  5040,    64,  -770,
    -770,    43,    45,  -770,    76,    61,    50,  -770,  -770,   984,
    5298,   411,    15,  2544,    22,  5040,   159,  -770,   -10,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,    83,
    -770,  -770,  -770,  5040,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  5040,  5040,  5040,  5040,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
     -21,  5040,  5040,  5040,  4125,  -770,  5040,  5040,  5040,  5040,
    -770,  -770,  -770,  5040,  5040,  5040,  5040,  5040,  -770,   115,
      59,  -770,  -770,  -770,  -770,  -770,  -770,  -770,    79,    86,
     104,   116,   119,   126,   147,   153,   175,  -770,   180,   188,
     191,   200,   231,   234,   248,   250,   252,   265,  2083,  -770,
    2083,  2083,  4389,    38,    -5,  -770,  4518,  3030,  -770,   268,
     -15,  -770,  4518,    49,    92,  -770,    31,    67,    96,  5040,
    5427,  5040,  3720,    93,   102,   122,  4653,   212,  -770,   247,
    -770,  -770,   247,  -770,  -770,  -770,  -770,   247,  -770,   247,
     196,  -770,  -770,  5169,   297,  -770,  -770,  -770,   278,   280,
     303,   305,   309,   310,   311,  -770,   315,   317,   322,   489,
    2544,    52,   129,  -770,   238,   195,    81,  -770,  5040,  -770,
     -41,  -770,  2083,   166,  -770,  5040,   377,    85,   398,    88,
     376,    69,    73,   396,   383,  -770,  -770,  -770,  -770,  -770,
       5,  -770,   384,  -770,  -770,    73,   196,   452,   401,  1141,
    2083,  2240,     1,  2240,  2240,   355,  2083,  2240,  2240,  2083,
    2083,  1298,  2240,  2083,  2083,   359,   362,   364,   365,  -770,
    -770,  5845,  -770,  -770,   -35,   387,  -770,  -770,  2397,    52,
    -770,  2952,  1455,  5040,  -770,  -770,  2083,  2083,  2083,  2083,
    2083,  2083,  2083,  2083,  2083,  2083,  2083,  2083,  2083,  2083,
    2083,  2083,  2083,  2083,   517,   515,  -770,  -770,  -770,   370,
     -12,  2083,  3720,  3720,   477,   393,   394,   481,  -770,  -770,
    -770,  -770,  -770,     9,  -770,  3180,   466,   424,    12,   426,
    -770,   537,  -770,  -770,  -770,  -770,  5040,  -770,  -770,    41,
      32,     3,  5040,  5040,  5040,   399,  5040,   391,   395,  5040,
    5040,   400,  -770,   124,  2544,  2544,   397,   403,   106,    25,
      -6,    90,   100,   106,   106,   106,   106,   201,    39,   404,
      39,    39,    39,    39,    39,    39,    58,    39,    39,   419,
    5040,  5040,  6073,  -770,  4518,     7,  1612,  5556,   380,  -770,
     406,  -770,   247,  5040,  5040,  -770,   527,   528,   459,  -770,
    -770,  -770,   283,    53,  -770,  -770,  -770,   409,  -770,    17,
     552,   433,  -770,  -770,   226,   585,  2680,  -770,   586,  -770,
    -770,   587,  -770,   588,   455,  1769,  -770,  6073,   133,  -770,
    5880,   135,  5040,   442,   140,   142,  -770,  5919,   148,   150,
    3006,  5633,  -770,   154,   157,  5704,  5951,  -770,  1926,  2083,
    2083,  -770,  4389,  -770,  3585,   438,  5560,  -770,  -770,     5,
    -770,  6073,  -770,  -770,  -770,   472,   607,   622,   339,   457,
    -770,   457,   203,   203,   203,   203,    10,    10,  -770,  -770,
    -770,  6058,   468,  -770,  2240,  -770,   539,   457,   479,   479,
     621,   474,  3450,   623,  3720,  3720,  -770,  -770,  -770,  -770,
    -770,  -770,   555,   247,  -770,   247,  -770,   491,   476,  -770,
    -770,   524,   631,  -770,   526,   634,  5040,  -770,  -770,   486,
     487,    52,   488,   492,   493,  -770,  -770,   495,    52,   497,
    -770,  -770,  -770,   507,  -770,   649,   649,   519,   520,  -770,
      27,  -770,   574,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,   508,   514,    39,
      47,   533,    39,  -770,  -770,  -770,  -770,  -770,  -770,    39,
     518,  -770,  -770,   563,  -770,    72,    14,  -770,   535,  -770,
    -770,  -770,  2083,   589,  2083,  4782,   545,  -770,  -770,  -770,
    5040,  5040,  5040,  -770,  -770,  -770,  -770,   177,   192,    69,
     523,  -770,  4911,    73,  -770,  -770,  -770,  -770,  -770,   567,
     570,   530,  -770,   548,   223,  -770,  -770,  -770,  1455,   532,
    -770,  2240,  -770,  -770,   538,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  2083,  -770,  2083,  -770,  -770,  2083,  -770,  5739,
    5773,   550,  -770,  -770,  -770,  -770,  -770,   582,   636,  -770,
    5040,   691,   208,  -770,   558,    39,  -770,  -770,   560,   479,
    -770,   168,  -770,  -770,  2816,  5040,  -770,  -770,  -770,  -770,
     561,   559,  -770,  -770,  -770,  -770,  -770,  -770,  -770,   696,
    -770,   210,   215,   106,   106,   217,   219,  -770,   649,   649,
     566,  -770,    27,    39,   221,   568,    39,  -770,    87,  5040,
     196,   106,  -770,   679,   632,  -770,   551,  -770,  -770,  -770,
     235,   557,   613,  -770,   575,  -770,    39,  -770,   706,    11,
    -770,   433,  -770,  -770,  -770,  -770,  -770,   707,   708,   709,
    2544,  2680,   562,  -770,  -770,  5989,  6025,  5811,  3585,  1455,
     564,   713,   591,   655,  -770,  -770,  3450,   237,   569,     4,
     624,  -770,  -770,  -770,  -770,  5040,   573,  -770,   715,  5040,
     576,  -770,   716,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
     240,   242,    39,   245,   256,  -770,  -770,    39,   275,    55,
    -770,  -770,  -770,  -770,  -770,  -770,  3855,  -770,  -770,  4782,
      73,   -27,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,   605,  -770,  -770,  -770,  -770,  -770,   578,
     129,   599,  4260,   604,  -770,  -770,   583,  -770,    -1,   652,
    -770,   714,   686,   685,  -770,  5040,  -770,  -770,  -770,    39,
    -770,  -770,  -770,   620,   282,  -770,   768,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,   286,
     625,   186,   619,  -770,  -770,   291,  -770,   775,   557,  -770,
    -770,  -770,  2544,  -770,  -770,  -770,   627,  -770,  -770,  2240,
    5040,   750,   702,  3990,   692,  3315,   589,   626,   293,    39,
    -770,  5040,   629,  -770,   630,  -770,  -770,  3990,  -770,    73,
     646,   637,  -770,  -770,   129,  4260,   296,  3990,   784,  -770,
    -770,   638,   761,  -770,   632,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,   786,   775,  -770,   639,   619,   640,  3990,
    3990,   196,  -770,  -770,   643,   795,  -770,   619,  -770,  2240,
    -770,   306,   644,  -770
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       0,     0,     0,   412,     0,   409,     0,   557,     0,   459,
     458,     0,     0,   415,     0,     0,     0,   416,   410,     0,
     496,   496,     0,     0,     0,     0,     0,     2,     3,   143,
     146,   149,   151,   147,   148,     7,     8,   411,     5,     0,
       6,     9,    10,     0,    11,    12,    13,    28,    14,    15,
      16,    23,    17,    18,    19,    20,    21,    22,    34,    35,
      24,    25,    26,    27,    29,    30,    31,    32,    33,    36,
      37,    38,    39,    40,     0,     0,     0,     0,    41,    42,
      43,    45,    44,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,   142,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    79,    78,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,   140,    99,    98,   100,
     101,   102,   103,   105,   104,   106,   107,   109,   110,   108,
     111,   112,   113,   114,   116,   117,   115,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   141,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
       0,     0,     0,     0,   558,   556,     0,     0,     0,     0,
     515,   516,   517,     0,     0,     0,     0,     0,   554,     0,
      41,   302,   304,   305,   542,   307,   522,   306,    44,    46,
      50,    53,    63,    70,    72,    79,    78,   303,     0,    83,
      86,    93,    95,   105,     0,   108,   123,   135,     0,   168,
       0,     0,     0,   301,     0,   166,   170,   173,   329,     0,
     283,   519,   170,     0,   330,   331,     0,     0,    56,    58,
      76,    82,     0,   115,     0,     0,     0,     0,   493,   364,
     497,   380,   364,   371,   372,   370,   498,   364,   381,   364,
     287,   366,   363,     0,     0,   413,   242,   254,    44,    46,
      53,    63,    70,     0,    79,   246,    86,     0,   135,     0,
       0,   241,   555,   193,     0,     0,     0,   247,     0,   182,
       0,     1,     0,     4,   145,     0,   456,     0,     0,     0,
       0,     0,   562,     0,     0,   560,   398,   397,   559,   565,
       0,   509,     0,   514,   513,   562,   287,   551,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    41,    93,    95,   308,
     309,     0,   360,   359,     0,     0,   536,   537,     0,   533,
     534,     0,     0,     0,   171,   169,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   518,   284,   521,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   407,   408,
     406,   405,   404,   387,   402,     0,     0,     0,   364,     0,
     494,     0,   461,   368,   367,   460,     0,   373,   288,   121,
     382,   487,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   255,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   525,
       0,     0,   547,   548,   170,   543,     0,     0,     0,   144,
     417,   457,   364,     0,     0,   482,     0,     0,     0,   256,
     430,   258,     0,     0,   428,   429,   442,   446,   440,     0,
     451,   563,   448,   564,     0,     0,     0,   438,     0,   561,
     527,     0,   553,     0,   353,     0,   341,   352,     0,   350,
       0,     0,     0,     0,     0,     0,   180,     0,     0,     0,
       0,     0,   347,     0,     0,     0,     0,   344,     0,     0,
       0,   327,     0,   328,     0,   542,     0,   535,   160,   184,
     167,   173,   172,   319,   320,   326,   325,   317,   316,   323,
     540,   324,   314,   315,   321,   322,   310,   311,   312,   313,
     318,     0,   285,   520,     0,   332,     0,   541,   389,   390,
       0,     0,     0,     0,     0,     0,   400,   386,   399,   401,
     385,   384,     0,   364,   369,   364,   365,   292,   289,   290,
     379,     0,     0,   376,     0,     0,     0,   485,   488,     0,
       0,     0,     0,     0,     0,   251,   244,     0,   532,     0,
     531,   245,   196,   195,   194,     0,     0,     0,     0,   207,
       0,   226,     0,   224,   197,   215,   225,   198,   216,   212,
     221,   211,   220,   214,   223,   213,   222,     0,     0,     0,
       0,     0,     0,   230,   231,   236,   237,   238,   239,     0,
       0,   228,   229,     0,   524,     0,     0,   463,     0,   183,
     546,   545,     0,   274,     0,     0,     0,   455,   483,   484,
       0,     0,     0,   257,   444,   432,   259,     0,     0,     0,
       0,   452,     0,     0,   505,   506,   504,   508,   507,     0,
       0,    92,   186,   187,   188,   529,   552,   530,     0,     0,
     334,     0,   174,   338,     0,   179,   340,   339,   178,   335,
     337,   175,     0,   176,     0,   348,   349,     0,   177,     0,
       0,     0,   362,   361,   357,   539,   538,     0,   263,   185,
       0,     0,     0,   333,     0,     0,   393,   392,     0,   388,
     403,     0,   374,   375,     0,     0,   378,   383,   377,   486,
       0,   489,   490,   253,   252,   250,   243,   249,   248,     0,
     261,     0,     0,     0,     0,     0,     0,   227,     0,     0,
       0,   208,     0,     0,     0,     0,     0,   526,     0,     0,
     287,     0,   549,     0,   283,   275,   544,   420,   419,   421,
       0,     0,     0,   481,   511,   431,     0,   443,     0,   451,
     441,   447,   439,   454,   453,   450,   449,     0,     0,     0,
       0,     0,   153,   351,   181,     0,     0,     0,     0,     0,
       0,   265,   271,     0,   286,   336,     0,     0,     0,     0,
       0,   502,   495,   294,   297,     0,   293,   291,     0,     0,
       0,   205,     0,   203,   209,   218,   219,   217,   199,   201,
       0,     0,     0,     0,     0,   234,   232,     0,     0,     0,
     465,   466,   464,   462,   469,   470,     0,   550,   418,     0,
       0,   433,   423,   472,   474,   473,   479,   471,   477,   475,
     476,   478,   480,     0,   510,   260,   445,   503,   528,     0,
     189,   190,     0,     0,   343,   342,     0,   358,     0,     0,
     266,     0,     0,   269,   272,     0,   396,   395,   391,     0,
     500,   499,   501,     0,     0,   298,     0,   492,   491,   240,
     262,   206,   204,   210,   200,   202,   235,   233,   468,     0,
     105,   280,   276,   278,   422,     0,   426,     0,     0,   414,
     512,   192,     0,   158,   159,   157,   154,   155,   150,     0,
       0,     0,   162,     0,     0,     0,   274,     0,     0,     0,
     295,     0,     0,   467,     0,   281,   282,     0,   425,     0,
       0,   434,   435,   424,   191,     0,     0,     0,     0,   152,
     267,   264,     0,   270,   283,   345,   394,   300,   299,   296,
     277,   279,   427,     0,     0,   156,     0,   161,   163,     0,
       0,   287,   437,   436,     0,     0,   268,   273,   165,     0,
     164,     0,     0,   346
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -770,  -770,  -770,    -9,    -4,  -770,   499,  -770,   298,  -770,
    -770,  -171,  -770,  -770,  -770,    78,   -11,   447,  -230,  -770,
       8,  -770,  -501,  -770,     0,   -17,  -145,  -716,  -770,  -125,
    -418,  -605,  -571,  -770,  -770,  -770,  -770,  -770,  -770,  -144,
    -770,  -769,  -154,  -768,  -770,  -325,  -770,  -770,    70,  -770,
    -143,   207,  -770,  -324,   118,  -770,  -770,   284,     2,  -770,
    -214,  -770,  -770,  -770,  -770,  -770,  -397,  -770,  -363,   246,
    -770,  -770,  -770,  -770,  -770,   -52,  -770,  -770,  -115,  -770,
    -309,  -770,  -770,  -170,  -770,  -770,  -770,   146,  -770,  -770,
     149,   143,  -770,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,    48,  -770,  -770,  -770,  -770,  -770,  -770,    -7,  -770,
    -770,  -770,   808,  -770,  -770,  -770,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -770,   445,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,  -770,  -425,   -19,  -770,   478,  -770,
     461,  -770,  -770,   174,  -770,   176,  -770,  -770,  -770,  -770,
    -770,  -770,  -770,  -770,   513,  -770,  -770
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    26,    27,   179,   233,    28,    29,    30,    31,   893,
     946,   947,   727,   952,   979,    32,   234,   235,   365,   236,
     539,   728,   497,   692,   693,   614,   293,   294,   295,   296,
     485,   677,   761,   822,   901,   981,   956,   903,   904,   784,
     785,   932,   933,   386,   387,   417,   418,   588,   589,   914,
     915,   507,   238,   508,   509,   239,   354,   355,   724,    33,
     412,   272,   273,   594,    34,    35,   318,   581,   403,   404,
      36,    37,    38,    39,   666,   789,   790,   871,   872,   935,
     490,   939,   971,   972,    40,    41,   487,   488,   678,   680,
     491,   492,   682,   805,    42,   472,    43,    44,    45,    46,
     656,   657,   882,    47,    48,   597,   598,   751,   752,    49,
      50,    51,   255,   832,    52,   689,    53,    54,   884,    55,
      56,    57,    58,    59,    60,   240,   241,   242,    61,    62,
     654,    63,    64,    65,    66,   243,   244,   359,   360,   245,
     246,   663,   664,   463,   464,   465,   304,   502,    67,    68,
      69,    70,   185,    71,   493,    72,    73
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     180,   500,   486,   184,   297,   609,   292,   511,   580,   514,
     515,   254,   388,   518,   519,   765,   867,   523,   524,   291,
     618,   299,   277,   625,   628,   630,   632,   634,   636,   568,
     569,   681,   277,   300,   619,   760,   661,   774,   729,   306,
     302,  -364,   910,   574,   277,   762,   591,   512,   413,   766,
     361,   356,   357,   414,   950,   415,   771,   366,   277,    74,
     277,   674,   937,   384,   592,   356,   357,   181,   190,   460,
     307,   308,   309,   310,   277,   479,   565,   480,   277,   479,
     595,   480,   621,   481,   649,   356,   357,   481,    77,   411,
     182,  -364,   277,   479,   367,   277,   479,   186,   623,   188,
     473,   481,  -532,   476,   481,   277,   479,   191,   626,   195,
    -532,   277,   479,   389,   481,   197,   198,   461,   411,   187,
     481,   390,   650,   532,   192,   533,   196,   183,  -121,   298,
     827,   938,   911,    75,   474,   311,   189,   477,   596,   275,
     496,   566,   193,   385,   199,   303,    76,   622,   593,   496,
     931,   513,   194,   362,   305,   780,  -531,   362,   575,   301,
     380,   381,   382,   461,  -531,   662,   289,   853,  -442,  -442,
     328,   858,   779,   391,   675,   737,   289,   312,   313,   314,
     317,   620,   319,   299,   321,   322,   484,   484,   289,   323,
     324,   325,   326,   327,   584,   320,  -364,   850,   851,   358,
     484,   854,   289,   772,   289,   590,   393,   965,   997,   392,
     675,   739,   928,   358,   778,   329,  1001,  -498,   482,   637,
     638,   448,   482,   457,   458,   483,   237,   639,   353,   489,
     966,  1007,   364,   358,   660,  -355,   482,   980,   364,   482,
     732,   396,  -354,   859,   405,   394,   406,   397,   402,   482,
     366,   931,   409,   684,   929,   482,   436,   437,   667,   449,
     330,   931,   434,   435,   438,   640,   829,   434,   435,   420,
     830,   297,   331,   433,   466,   332,   467,   831,   685,   468,
     579,   612,   333,  1006,   931,   416,   291,   367,   432,   673,
     700,   701,   703,   701,   459,   686,   687,   706,   701,   707,
     701,   470,   439,   334,   958,   709,   701,   710,   701,   335,
     440,   715,   701,   617,   716,   701,   624,   627,   629,   631,
     633,   635,   410,   641,   411,   643,   644,   645,   646,   647,
     648,   336,   651,   652,   795,   796,   337,   450,   451,   452,
     453,   454,   455,   688,  -356,   845,   847,   338,   456,   797,
     798,   378,   379,   380,   381,   382,   339,   299,   676,   542,
     861,   434,   811,   865,   676,   825,   701,   841,   842,   742,
     799,   743,   843,   842,   848,   796,   849,   842,   856,   796,
     441,   442,   443,   444,   445,   446,   366,   340,   402,   402,
     341,   447,   868,   869,   908,   796,   256,   921,   842,   922,
     842,   317,   924,   796,   342,   602,   343,   604,   344,   723,
     607,   610,   587,   925,   842,   297,   297,   613,   599,   600,
     601,   345,   601,   367,   383,   601,   608,   256,   421,   907,
     291,   291,   927,   796,   422,   349,   423,   350,   351,   960,
     961,   658,   257,   963,   796,   261,   258,   736,   968,   969,
     986,   796,   259,   996,   701,   863,   655,   659,   254,   424,
     364,   425,   262,  1012,   701,   426,   427,   428,   260,   668,
     669,   429,   263,   430,   264,   265,   261,   297,   431,   694,
     957,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   291,   262,   432,   676,   267,   471,   475,   478,
     268,   494,   270,   263,   366,   264,   265,   501,   704,   462,
     495,   498,   516,   271,   770,   503,   527,   676,   528,   366,
     529,   530,   562,   266,   775,   206,   564,   267,   353,   534,
     722,   268,   269,   270,   570,   571,   572,   510,   573,   582,
     583,   367,   585,   517,   271,   586,   520,   521,   605,   603,
     525,   526,   606,   615,   484,   653,   367,   611,   484,   616,
     642,   936,   665,   670,   671,   536,   672,   679,   317,   541,
     402,   402,   681,   543,   544,   545,   546,   547,   548,   549,
     551,   552,   553,   554,   555,   556,   557,   558,   559,   560,
     561,   683,   750,   690,   695,   696,   697,  -542,   567,   705,
     725,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     676,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   976,   731,   733,   575,   734,
     735,   741,   738,   744,   745,   746,   747,   748,   844,   846,
     873,   874,   749,   753,   754,   755,   435,   676,   855,   756,
     757,   676,   758,   860,   366,   759,   864,   760,   763,   764,
     992,   788,   767,   777,   768,   875,   792,   793,   794,   366,
     769,   885,   773,   541,   776,   791,  1008,   781,   804,   783,
     802,   807,   876,   877,   808,  1011,   809,   810,   878,   812,
     819,   367,   818,   723,   821,   814,   824,   839,   879,   880,
     826,   906,   828,   838,   840,   852,   367,   857,   866,   662,
     384,   883,   351,   870,   886,   887,   888,   889,   900,   905,
     892,   899,   912,   917,   920,   909,   823,   923,   902,   916,
     881,   940,   926,   919,   676,   941,   719,   720,   942,   949,
     836,   587,   951,   953,   954,   484,   955,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     658,   948,   959,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   655,   962,   967,   970,   977,
     978,   964,   982,   985,   676,   975,   989,   990,   993,   998,
    1000,   297,   297,   890,  1002,   994,   999,  1004,  1005,  1009,
    1010,  1013,   469,   699,   995,   820,   291,   291,   898,   540,
     983,   891,   984,   991,   722,   837,   721,   934,   988,   813,
     897,   740,   317,   973,  1003,   800,   806,   862,   801,   274,
     563,   913,   918,   550,   987,   750,   782,   537,   499,     0,
     786,     0,     0,     0,   484,     0,     0,   297,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   291,     0,     0,   788,     0,     0,     0,   462,
       0,   462,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   610,     0,   945,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   608,     0,     0,     0,   541,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   815,
       0,   816,     0,   297,   817,   974,     0,     0,     0,     0,
       0,     0,     0,     0,   297,     0,   297,     0,   291,     0,
       0,     0,     0,     0,     0,     0,   299,     0,   297,   291,
       0,   291,     0,     0,     0,     0,     0,   913,   297,     0,
       0,     0,     0,   291,     0,     0,     0,     0,     0,     0,
       0,   945,     0,   291,     0,     0,     0,     0,     0,     0,
     297,   297,     0,     0,     0,     0,     0,   200,   201,   202,
     203,     0,   204,   205,   206,   291,   291,     0,   207,    79,
      80,    81,   208,   209,     0,    84,    85,    86,   210,    88,
      89,   211,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   212,   102,   103,   541,   104,   105,   106,
     107,     0,   213,   109,     0,     0,   214,   111,   112,     0,
     113,   114,   115,   215,   216,   118,   119,   217,   218,   120,
       0,   219,   122,   123,   220,   125,     0,   126,     0,   127,
     128,   129,     0,     0,   130,   221,   132,   222,     0,   134,
     135,   136,     0,   137,     0,   138,   139,   140,   141,   142,
     223,   144,   145,   224,   146,     0,   147,   148,   225,   150,
     151,   152,     0,   153,   154,   155,   156,   157,   158,   159,
     160,   161,     0,   226,   163,   164,   165,   166,   167,     0,
     168,   169,   170,   171,   172,   173,     0,   174,   227,   176,
     177,   178,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   228,   229,     0,     0,   230,     0,     0,
     231,     0,     0,   232,   346,   201,   202,   203,     0,   504,
     205,     0,     0,     0,     0,   207,    79,    80,    81,   208,
     209,     0,    84,    85,    86,    87,    88,    89,   211,    91,
       0,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   106,   107,     0,   213,
     109,     0,     0,   214,   111,   112,     0,   113,   114,   115,
     116,   117,   118,   119,   217,   218,   120,     0,   219,   122,
     123,   220,   125,     0,   126,     0,   127,   128,   129,     0,
       0,   130,   347,   132,   348,     0,   134,   135,   136,     0,
     137,     0,   138,   139,   140,   141,   142,   223,   144,   145,
     224,   146,     0,   147,   148,   225,   150,   151,   152,     0,
     153,   154,   155,   156,   157,   158,   159,   160,   161,     0,
     162,   163,   164,   165,   166,   167,     0,   168,   169,   170,
     171,   172,   173,     0,   174,   227,   176,   177,   178,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     228,     0,     0,     0,   230,     0,     0,   505,   506,     0,
     232,   346,   201,   202,   203,     0,   504,   205,     0,     0,
       0,     0,   207,    79,    80,    81,   208,   209,     0,    84,
      85,    86,    87,    88,    89,   211,    91,     0,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   106,   107,     0,   213,   109,     0,     0,
     214,   111,   112,     0,   113,   114,   115,   116,   117,   118,
     119,   217,   218,   120,     0,   219,   122,   123,   220,   125,
       0,   126,     0,   127,   128,   129,     0,     0,   130,   347,
     132,   348,     0,   134,   135,   136,     0,   137,     0,   138,
     139,   140,   141,   142,   223,   144,   145,   224,   146,     0,
     147,   148,   225,   150,   151,   152,     0,   153,   154,   155,
     156,   157,   158,   159,   160,   161,     0,   162,   163,   164,
     165,   166,   167,     0,   168,   169,   170,   171,   172,   173,
       0,   174,   227,   176,   177,   178,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   228,     0,     0,
       0,   230,     0,     0,   231,   522,     0,   232,   346,   201,
     202,   203,     0,   204,   205,     0,     0,     0,     0,   207,
      79,    80,    81,   208,   209,     0,    84,    85,    86,   210,
      88,    89,   211,    91,     0,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   212,   102,   103,     0,   104,   105,
     106,   107,     0,   213,   109,     0,     0,   214,   111,   112,
       0,   113,   114,   115,   215,   216,   118,   119,   217,   218,
     120,     0,   219,   122,   123,   220,   125,     0,   126,     0,
     127,   128,   129,     0,     0,   130,   221,   132,   222,     0,
     134,   135,   136,     0,   137,     0,   138,   139,   140,   141,
     142,   223,   144,   145,   224,   146,     0,   147,   148,   225,
     150,   151,   152,     0,   153,   154,   155,   156,   157,   158,
     159,   160,   161,     0,   226,   163,   164,   165,   166,   167,
       0,   168,   169,   170,   171,   172,   173,     0,   174,   227,
     176,   177,   178,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   228,   229,     0,     0,   230,     0,
       0,   231,     0,     0,   232,   200,   201,   202,   203,     0,
     204,   205,     0,     0,     0,     0,   207,    79,    80,    81,
     208,   209,     0,    84,    85,    86,   210,    88,    89,   211,
      91,     0,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   212,   102,   103,     0,   104,   105,   106,   107,     0,
     213,   109,     0,     0,   214,   111,   112,     0,   113,   114,
     115,   215,   216,   118,   119,   217,   218,   120,     0,   219,
     122,   123,   220,   125,     0,   126,     0,   127,   128,   129,
       0,     0,   130,   221,   132,   222,     0,   134,   135,   136,
       0,   137,     0,   138,   139,   140,   141,   142,   223,   144,
     145,   224,   146,     0,   147,   148,   225,   150,   151,   152,
       0,   153,   154,   155,   156,   157,   158,   159,   160,   161,
       0,   226,   163,   164,   165,   166,   167,     0,   168,   169,
     170,   171,   172,   173,     0,   174,   227,   176,   177,   178,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   228,   229,     0,     0,   230,     0,     0,   231,     0,
       0,   232,   346,   201,   202,   203,     0,   204,   205,     0,
       0,     0,     0,   207,    79,    80,    81,   208,   209,     0,
      84,    85,    86,    87,    88,    89,   211,    91,     0,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   106,   107,     0,   213,   109,     0,
       0,   214,   111,   112,     0,   113,   114,   115,   116,   117,
     118,   119,   217,   218,   120,     0,   219,   122,   123,   220,
     125,     0,   126,     0,   127,   128,   129,     0,     0,   130,
     347,   132,   348,     0,   134,   135,   136,     0,   137,     0,
     138,   139,   140,   141,   142,   223,   144,   145,   224,   146,
       0,   147,   148,   225,   150,   151,   152,   698,   153,   154,
     155,   156,   157,   158,   159,   160,   161,     0,   162,   163,
     164,   165,   166,   167,     0,   168,   169,   170,   171,   172,
     173,     0,   174,   227,   176,   177,   178,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   228,     0,
       0,     0,   230,     0,     0,   231,     0,     0,   232,   346,
     201,   202,   203,     0,   504,   205,     0,     0,     0,     0,
     207,    79,    80,    81,   208,   209,     0,    84,    85,    86,
      87,    88,    89,   211,    91,     0,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   106,   107,     0,   213,   109,     0,     0,   214,   111,
     112,     0,   113,   114,   115,   116,   117,   118,   119,   217,
     218,   120,     0,   219,   122,   123,   220,   125,     0,   126,
       0,   127,   128,   129,     0,     0,   130,   347,   132,   348,
       0,   134,   135,   136,     0,   137,     0,   138,   139,   140,
     141,   142,   223,   144,   145,   224,   146,     0,   147,   148,
     225,   150,   151,   152,     0,   153,   154,   155,   156,   157,
     158,   159,   160,   161,     0,   162,   163,   164,   165,   166,
     167,     0,   168,   169,   170,   171,   172,   173,     0,   174,
     227,   176,   177,   178,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   228,     0,     0,     0,   230,
       0,     0,   231,   506,     0,   232,   346,   201,   202,   203,
       0,   204,   205,     0,     0,     0,     0,   207,    79,    80,
      81,   208,   209,     0,    84,    85,    86,    87,    88,    89,
     211,    91,     0,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   106,   107,
       0,   213,   109,     0,     0,   214,   111,   112,     0,   113,
     114,   115,   116,   117,   118,   119,   217,   218,   120,     0,
     219,   122,   123,   220,   125,     0,   126,     0,   127,   128,
     129,     0,     0,   130,   347,   132,   348,     0,   134,   135,
     136,     0,   137,     0,   138,   139,   140,   141,   142,   223,
     144,   145,   224,   146,     0,   147,   148,   225,   150,   151,
     152,     0,   153,   154,   155,   156,   157,   158,   159,   160,
     161,     0,   162,   163,   164,   165,   166,   167,     0,   168,
     169,   170,   171,   172,   173,     0,   174,   227,   176,   177,
     178,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   228,     0,     0,     0,   230,     0,     0,   231,
       0,     0,   232,   346,   201,   202,   203,     0,   504,   205,
       0,     0,     0,     0,   207,    79,    80,    81,   208,   209,
       0,    84,    85,    86,    87,    88,    89,   211,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   106,   107,     0,   213,   109,
       0,     0,   214,   111,   112,     0,   113,   114,   115,   116,
     117,   118,   119,   217,   218,   120,     0,   219,   122,   123,
     220,   125,     0,   126,     0,   127,   128,   129,     0,     0,
     130,   347,   132,   348,     0,   134,   135,   136,     0,   137,
       0,   138,   139,   140,   141,   142,   223,   144,   145,   224,
     146,     0,   147,   148,   225,   150,   151,   152,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   161,     0,   162,
     163,   164,   165,   166,   167,     0,   168,   169,   170,   171,
     172,   173,     0,   174,   227,   176,   177,   178,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   228,
       0,     0,     0,   230,     0,     0,   231,     0,     0,   232,
     346,   201,   202,   203,     0,   535,   205,     0,     0,     0,
       0,   207,    79,    80,    81,   208,   209,     0,    84,    85,
      86,    87,    88,    89,   211,    91,     0,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   106,   107,     0,   213,   109,     0,     0,   214,
     111,   112,     0,   113,   114,   115,   116,   117,   118,   119,
     217,   218,   120,     0,   219,   122,   123,   220,   125,     0,
     126,     0,   127,   128,   129,     0,     0,   130,   347,   132,
     348,     0,   134,   135,   136,     0,   137,     0,   138,   139,
     140,   141,   142,   223,   144,   145,   224,   146,     0,   147,
     148,   225,   150,   151,   152,     0,   153,   154,   155,   156,
     157,   158,   159,   160,   161,     0,   162,   163,   164,   165,
     166,   167,     0,   168,   169,   170,   171,   172,   173,     0,
     174,   227,   176,   177,   178,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   228,    78,   276,   277,
     230,     0,     0,   231,     0,     0,   232,     0,     0,    79,
      80,    81,   278,   279,     0,    84,    85,    86,    87,    88,
      89,   280,    91,     0,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   281,   102,   103,     0,   104,   105,   106,
     107,     0,   282,   109,   283,     0,   110,   111,   112,     0,
     113,   114,   115,   284,   117,   118,   119,   285,     0,   120,
       0,   121,   122,   123,   286,   125,     0,   126,     0,   127,
     128,   129,     0,     0,   130,   131,   132,   133,     0,   134,
     135,   136,     0,   137,     0,   138,   139,   140,   141,   142,
     143,   144,   145,   287,   146,     0,   147,   148,   149,   150,
     151,   152,     0,   153,   154,   155,   156,   157,   158,   159,
     160,   161,     0,   162,   163,   164,   165,   166,   167,     0,
     168,   169,   170,   171,   172,   173,     0,   174,   288,   176,
     177,   178,     0,    78,   276,   277,     0,     0,     0,     0,
       0,     0,     0,   289,     0,    79,    80,    81,   278,   279,
     290,    84,    85,    86,    87,    88,    89,   280,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   281,
     102,   103,     0,   104,   105,   106,   107,     0,   282,   109,
     283,     0,   110,   111,   112,     0,   113,   114,   115,   284,
     117,   118,   119,   285,     0,   120,     0,   121,   122,   123,
     286,   125,     0,   126,     0,   127,   128,   129,     0,     0,
     691,   131,   132,   133,     0,   134,   135,   136,     0,   137,
       0,   138,   139,   140,   141,   142,   143,   144,   145,   287,
     146,     0,   147,   148,   149,   150,   151,   152,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   161,     0,   162,
     163,   164,   165,   166,   167,     0,   168,   169,   170,   171,
     172,   173,     0,   174,   288,   176,   177,   178,     0,    78,
       0,   833,     0,     0,   834,     0,     0,     0,     0,   289,
       0,    79,    80,    81,    82,    83,   290,    84,    85,    86,
      87,    88,    89,    90,    91,     0,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   106,   107,     0,   108,   109,     0,     0,   110,   111,
     112,     0,   113,   114,   115,   116,   117,   118,   119,     0,
       0,   120,     0,   121,   122,   123,   124,   125,     0,   126,
       0,   127,   128,   129,     0,     0,   130,   131,   132,   133,
       0,   134,   135,   136,     0,   137,     0,   138,   139,   140,
     141,   142,   143,   144,   145,     0,   146,     0,   147,   148,
     149,   150,   151,   152,     0,   153,   154,   155,   156,   157,
     158,   159,   160,   161,     0,   162,   163,   164,   165,   166,
     167,     0,   168,   169,   170,   171,   172,   173,     0,   174,
     175,   176,   177,   178,     0,    78,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    79,    80,    81,
      82,    83,   835,    84,    85,    86,    87,    88,    89,    90,
      91,     0,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   106,   107,     0,
     108,   109,     0,     0,   110,   111,   112,     0,   113,   114,
     115,   116,   117,   118,   119,     0,     0,   120,     0,   121,
     122,   123,   124,   125,     0,   126,     0,   127,   128,   129,
    -523,     0,   130,   131,   132,   133,     0,   134,   135,   136,
       0,   137,     0,   138,   139,   140,   141,   142,   143,   144,
     145,     0,   146,   366,   147,   148,   149,   150,   151,   152,
       0,   153,   154,   155,   156,   157,   158,   159,   160,   161,
       0,   162,   163,   164,   165,   166,   167,   366,   168,   169,
     170,   171,   172,   173,     0,   174,   175,   176,   177,   178,
     367,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   538,     0,
       0,     0,     0,     0,   367,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,     0,
       0,     0,     0,   711,   712,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,    78,     0,   277,     0,     0,   316,     0,
       0,     0,     0,     0,     0,    79,    80,    81,    82,    83,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   106,   107,     0,   108,   109,
       0,   576,   110,   111,   112,     0,   113,   114,   115,   116,
     117,   118,   119,     0,     0,   120,     0,   121,   122,   123,
     124,   125,     0,   126,     0,   127,   128,   129,     0,     0,
     130,   131,   132,   133,     0,   134,   135,   136,   577,   137,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
     146,     0,   147,   148,   149,   150,   151,   152,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   161,     0,   162,
     163,   164,   165,   166,   167,   578,   168,   169,   170,   171,
     172,   173,     0,   174,   175,   176,   177,   178,    78,   276,
     277,     0,     0,     0,     0,     0,     0,     0,     0,   289,
      79,    80,    81,   278,   279,     0,    84,    85,    86,    87,
      88,    89,   280,    91,     0,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   281,   102,   103,     0,   104,   105,
     106,   107,     0,   282,   109,   283,     0,   110,   111,   112,
       0,   113,   114,   115,   284,   117,   118,   119,   285,     0,
     120,     0,   121,   122,   123,   286,   125,     0,   126,     0,
     127,   128,   129,     0,     0,   130,   131,   132,   133,     0,
     134,   135,   136,     0,   137,     0,   138,   139,   140,   141,
     142,   143,   144,   145,   287,   146,     0,   147,   148,   149,
     150,   151,   152,     0,   153,   154,   155,   156,   157,   158,
     159,   160,   161,     0,   162,   163,   164,   165,   166,   167,
       0,   168,   169,   170,   171,   172,   173,     0,   174,   288,
     176,   177,   178,    78,     0,   277,     0,     0,   316,     0,
       0,     0,     0,     0,   289,    79,    80,    81,    82,    83,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   106,   107,     0,   108,   109,
       0,     0,   110,   111,   112,     0,   113,   114,   115,   116,
     117,   118,   119,     0,     0,   120,     0,   121,   122,   123,
     124,   125,     0,   126,     0,   127,   128,   129,     0,     0,
     130,   131,   132,   133,     0,   134,   135,   136,     0,   137,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
     146,     0,   147,   148,   149,   150,   151,   152,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   161,     0,   162,
     163,   164,   165,   166,   167,     0,   168,   169,   170,   171,
     172,   173,     0,   174,   175,   176,   177,   178,    78,     0,
     277,     0,     0,     0,     0,     0,     0,     0,     0,   289,
      79,    80,    81,    82,    83,     0,    84,    85,    86,    87,
      88,    89,    90,    91,     0,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     106,   107,     0,   108,   109,     0,     0,   110,   111,   112,
       0,   113,   114,   115,   116,   117,   118,   119,     0,     0,
     120,     0,   121,   122,   123,   124,   125,     0,   126,     0,
     127,   128,   129,     0,     0,   130,   131,   132,   133,     0,
     134,   135,   136,     0,   137,     0,   138,   139,   140,   141,
     142,   143,   144,   145,     0,   146,     0,   147,   148,   149,
     150,   151,   152,     0,   153,   154,   155,   156,   157,   158,
     159,   160,   161,     0,   162,   163,   164,   165,   166,   167,
       0,   168,   169,   170,   171,   172,   173,     0,   174,   175,
     176,   177,   178,    78,     0,   398,   399,     0,   400,     0,
       0,     0,     0,     0,   289,    79,    80,    81,    82,    83,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   106,   107,     0,   108,   109,
       0,     0,   110,   111,   112,     0,   113,   114,   115,   116,
     117,   118,   119,     0,     0,   120,     0,   121,   122,   123,
     124,   125,     0,   126,     0,   127,   128,   129,     0,     0,
     130,   131,   132,   133,     0,   134,   135,   136,   401,   137,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
     146,     0,   147,   148,   149,   150,   151,   152,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   161,     0,   162,
     163,   164,   165,   166,   167,     0,   168,   169,   170,   171,
     172,   173,     0,   174,   175,   176,   177,   178,    78,   276,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,    84,    85,    86,    87,
      88,    89,   280,    91,     0,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   281,   102,   103,     0,   104,   105,
     106,   107,     0,   282,   109,   283,     0,   110,   111,   112,
       0,   113,   114,   115,   284,   117,   118,   119,   285,     0,
     120,     0,   121,   122,   123,   286,   125,     0,   126,     0,
     127,   128,   129,     0,     0,   130,   131,   132,   133,     0,
     134,   135,   136,     0,   137,     0,   138,   139,   140,   141,
     142,   930,   144,   145,     0,   146,     0,   147,   148,   149,
     150,   151,   152,     0,   153,   154,   155,   156,   157,   158,
     159,   160,   161,     0,   162,   163,   164,   165,   166,   167,
       0,   168,   169,   170,   171,   172,   173,     0,   174,   288,
     176,   177,   178,    78,   276,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    79,    80,    81,    82,    83,
       0,    84,    85,    86,    87,    88,    89,   280,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   281,
     102,   103,     0,   104,   105,   106,   107,     0,   282,   109,
     283,     0,   110,   111,   112,     0,   113,   114,   115,   284,
     117,   118,   119,   285,     0,   120,     0,   121,   122,   123,
     286,   125,     0,   126,     0,   127,   128,   129,     0,     0,
     130,   131,   132,   133,     0,   134,   135,   136,     0,   137,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
     146,     0,   147,   148,   149,   150,   151,   152,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   161,     0,   162,
     163,   164,   165,   166,   167,     0,   168,   169,   170,   171,
     172,   173,     0,   174,   288,   176,   177,   178,    78,     0,
     315,     0,     0,   316,     0,     0,     0,     0,     0,     0,
      79,    80,    81,    82,    83,     0,    84,    85,    86,    87,
      88,    89,    90,    91,     0,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,     0,   104,   105,
     106,   107,     0,   108,   109,     0,     0,   110,   111,   112,
       0,   113,   114,   115,   116,   117,   118,   119,     0,     0,
     120,     0,   121,   122,   123,   124,   125,     0,   126,     0,
     127,   128,   129,     0,     0,   130,   131,   132,   133,     0,
     134,   135,   136,     0,   137,     0,   138,   139,   140,   141,
     142,   143,   144,   145,     0,   146,     0,   147,   148,   149,
     150,   151,   152,     0,   153,   154,   155,   156,   157,   158,
     159,   160,   161,     0,   162,   163,   164,   165,   166,   167,
       0,   168,   169,   170,   171,   172,   173,     0,   174,   175,
     176,   177,   178,    78,     0,   943,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    79,    80,    81,    82,    83,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   106,   107,     0,   108,   109,
       0,     0,   110,   111,   112,     0,   113,   114,   115,   116,
     117,   118,   119,   944,     0,   120,     0,   121,   122,   123,
     124,   125,     0,   126,     0,   127,   128,   129,     0,     0,
     130,   131,   132,   133,     0,   134,   135,   136,     0,   137,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
     146,     0,   147,   148,   149,   150,   151,   152,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   161,     0,   162,
     163,   164,   165,   166,   167,     0,   168,   169,   170,   171,
     172,   173,    78,   174,   175,   176,   177,   178,     0,     0,
       0,     0,     0,     0,    79,    80,    81,    82,    83,     0,
      84,    85,    86,    87,    88,    89,    90,    91,     0,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   106,   107,     0,   108,   109,     0,
       0,   110,   111,   112,     0,   113,   114,   115,   116,   117,
     118,   119,     0,   352,   120,     0,   121,   122,   123,   124,
     125,     0,   126,     0,   127,   128,   129,     0,     0,   130,
     131,   132,   133,     0,   134,   135,   136,     0,   137,     0,
     138,   139,   140,   141,   142,   143,   144,   145,     0,   146,
       0,   147,   148,   149,   150,   151,   152,     0,   153,   154,
     155,   156,   157,   158,   159,   160,   161,     0,   162,   163,
     164,   165,   166,   167,     0,   168,   169,   170,   171,   172,
     173,    78,   174,   175,   176,   177,   178,     0,     0,     0,
       0,     0,     0,    79,    80,    81,    82,    83,   363,    84,
      85,    86,    87,    88,    89,    90,    91,     0,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   106,   107,     0,   108,   109,     0,     0,
     110,   111,   112,     0,   113,   114,   115,   116,   117,   118,
     119,     0,     0,   120,     0,   121,   122,   123,   124,   125,
       0,   126,     0,   127,   128,   129,     0,     0,   130,   131,
     132,   133,     0,   134,   135,   136,     0,   137,     0,   138,
     139,   140,   141,   142,   143,   144,   145,     0,   146,     0,
     147,   148,   149,   150,   151,   152,     0,   153,   154,   155,
     156,   157,   158,   159,   160,   161,     0,   162,   163,   164,
     165,   166,   167,     0,   168,   169,   170,   171,   172,   173,
       0,   174,   175,   176,   177,   178,    78,     0,     0,     0,
       0,   407,     0,     0,     0,     0,     0,     0,    79,    80,
      81,    82,    83,     0,    84,    85,    86,    87,    88,    89,
      90,    91,     0,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,     0,   104,   105,   106,   107,
       0,   108,   109,     0,     0,   110,   111,   112,     0,   113,
     114,   115,   116,   117,   118,   119,     0,     0,   120,     0,
     121,   122,   123,   124,   125,     0,   126,     0,   127,   128,
     129,     0,     0,   130,   131,   132,   133,     0,   134,   135,
     136,     0,   137,     0,   138,   139,   140,   141,   142,   143,
     144,   145,     0,   146,     0,   147,   148,   149,   150,   151,
     152,     0,   153,   154,   155,   156,   157,   158,   159,   408,
     161,     0,   162,   163,   164,   165,   166,   167,     0,   168,
     169,   170,   171,   172,   173,    78,   174,   175,   176,   177,
     178,     0,     0,     0,     0,     0,     0,    79,    80,    81,
      82,    83,     0,    84,    85,    86,    87,    88,    89,    90,
      91,     0,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,     0,   104,   105,   106,   107,     0,
     108,   109,     0,     0,   110,   111,   112,     0,   113,   114,
     115,   116,   117,   118,   119,   787,     0,   120,     0,   121,
     122,   123,   124,   125,     0,   126,     0,   127,   128,   129,
       0,     0,   130,   131,   132,   133,     0,   134,   135,   136,
       0,   137,     0,   138,   139,   140,   141,   142,   143,   144,
     145,     0,   146,     0,   147,   148,   149,   150,   151,   152,
       0,   153,   154,   155,   156,   157,   158,   159,   160,   161,
       0,   162,   163,   164,   165,   166,   167,     0,   168,   169,
     170,   171,   172,   173,    78,   174,   175,   176,   177,   178,
       0,     0,     0,     0,     0,     0,    79,    80,    81,    82,
      83,     0,    84,    85,    86,    87,    88,    89,    90,    91,
       0,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,     0,   104,   105,   106,   107,     0,   108,
     109,     0,     0,   110,   111,   112,     0,   113,   114,   115,
     116,   117,   118,   119,     0,     0,   120,     0,   121,   122,
     123,   124,   125,     0,   126,     0,   127,   128,   129,   803,
       0,   130,   131,   132,   133,     0,   134,   135,   136,     0,
     137,     0,   138,   139,   140,   141,   142,   143,   144,   145,
       0,   146,     0,   147,   148,   149,   150,   151,   152,     0,
     153,   154,   155,   156,   157,   158,   159,   160,   161,     0,
     162,   163,   164,   165,   166,   167,     0,   168,   169,   170,
     171,   172,   173,    78,   174,   175,   176,   177,   178,     0,
       0,     0,     0,     0,     0,    79,    80,    81,    82,    83,
       0,    84,    85,    86,    87,    88,    89,    90,    91,     0,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,     0,   104,   105,   106,   107,     0,   108,   109,
       0,     0,   110,   111,   112,     0,   113,   114,   115,   116,
     117,   118,   119,     0,     0,   120,     0,   121,   122,   123,
     124,   125,     0,   126,     0,   127,   128,   129,     0,     0,
     130,   131,   132,   133,     0,   134,   135,   136,     0,   137,
       0,   138,   139,   140,   141,   142,   143,   144,   145,     0,
     146,     0,   147,   148,   149,   150,   151,   152,     0,   153,
     154,   155,   156,   157,   158,   159,   160,   161,     0,   162,
     163,   164,   165,   166,   167,     0,   168,   169,   170,   171,
     172,   173,    78,   174,   175,   176,   177,   178,     0,     0,
       0,     0,     0,     0,    79,    80,    81,    82,    83,     0,
      84,    85,    86,    87,    88,    89,    90,    91,     0,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,     0,   104,   105,   106,   107,     0,   108,   109,     0,
       0,   110,   111,   112,     0,   113,   114,   115,   116,   117,
     118,   119,     0,     0,   120,     0,   121,   122,   123,   124,
     125,     0,   126,     0,   127,   128,   129,     0,     0,   130,
     131,   132,   133,     0,   134,   135,   136,     0,   137,     0,
     138,   139,   140,   141,   142,   143,   144,   145,     0,   146,
       0,   147,   148,   149,   150,   151,   152,     0,   153,   154,
     155,   156,   157,   158,   159,   419,   161,     0,   162,   163,
     164,   165,   166,   167,     0,   168,   169,   170,   171,   172,
     173,    78,   174,   175,   176,   177,   178,     0,   247,     0,
       0,     0,     0,    79,    80,    81,    82,    83,     0,    84,
      85,    86,    87,    88,    89,    90,    91,     0,    92,   248,
      94,   249,     0,    97,    98,    99,   100,   101,   102,   103,
       0,   104,   105,   106,   107,     0,   108,   109,     0,     0,
     110,   111,   112,     0,   113,   250,   115,   116,   117,   118,
     119,     0,     0,   251,     0,   121,   122,   123,   124,   125,
       0,   126,     0,   127,   128,   129,     0,     0,   130,   131,
     132,   133,     0,   134,   135,   252,     0,   137,     0,   138,
     139,   140,   141,   142,   143,   144,   145,     0,   146,     0,
     147,   148,   149,   150,   151,   152,     0,   153,   154,   155,
     253,   157,   158,   159,   160,   161,     0,   162,   163,   164,
     165,   166,     0,     0,   168,   169,   170,   171,   172,   173,
      78,   174,   175,   176,   177,   178,   395,     0,     0,     0,
       0,     0,    79,    80,    81,    82,    83,     0,    84,    85,
      86,    87,    88,    89,    90,    91,     0,    92,    93,    94,
      95,     0,    97,    98,    99,   100,   101,   102,   103,     0,
     104,   105,   106,   107,     0,   108,   109,     0,     0,   110,
     111,   112,     0,   113,   114,   115,   116,   117,   118,   119,
       0,     0,   120,     0,   121,   122,   123,   124,   125,     0,
     126,     0,   127,   128,   129,     0,     0,   130,   131,   132,
     133,     0,   134,   135,     0,     0,   137,     0,   138,   139,
     140,   141,   142,   143,   144,   145,     0,   146,     0,   147,
     148,   149,   150,   151,   152,     0,   153,   154,   155,   156,
     157,   158,   159,   160,   161,     0,   162,   163,   164,   165,
     166,  -497,     0,   168,   169,   170,   171,   172,   173,    78,
     174,   175,   176,   177,   178,     0,   247,     0,     0,     0,
       0,    79,    80,    81,    82,    83,     0,    84,    85,    86,
      87,    88,    89,    90,    91,     0,    92,   248,    94,    95,
       0,    97,    98,    99,   100,   101,   102,   103,     0,   104,
     105,   106,   107,     0,   108,   109,     0,   366,   110,   111,
     112,     0,   113,   114,   115,   116,   117,   118,   119,     0,
       0,   120,     0,   121,   122,   123,   124,   125,     0,   126,
       0,   127,   128,   129,     0,     0,   130,   131,   132,   133,
       0,   134,   135,   252,   367,   137,     0,   138,   139,   140,
     141,   142,   143,   144,   145,     0,   146,     0,   147,   148,
     149,   150,   151,   152,     0,   153,   154,   155,   156,   157,
     158,   159,   160,   161,     0,   162,   163,   164,   165,   166,
     366,     0,   168,   169,   170,   171,   172,   173,     0,   174,
     175,   176,   177,   178,     0,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     1,     0,     0,     0,   367,     2,     0,
       0,     3,   726,     0,     0,     0,     4,     0,     0,     0,
       0,     0,     0,     5,     0,     0,     6,     0,     7,     8,
       9,    10,     0,     0,     0,    11,     0,     0,     0,    12,
       0,   366,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    13,     0,     0,     0,     0,     0,
      14,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,   366,    15,   367,     0,
     713,   714,     0,     0,     0,     0,     0,    16,     0,    17,
       0,     0,    18,     0,    19,     0,    20,     0,     0,    21,
       0,    22,     0,     0,    23,     0,     0,     0,     0,     0,
     366,     0,    24,   367,     0,    25,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   368,   369,   370,   371,   372,   373,   374,   375,
     376,   377,   378,   379,   380,   381,   382,   367,   366,     0,
       0,     0,   717,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   366,     0,     0,   367,     0,   712,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382,     0,   366,     0,   367,
       0,   714,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,   367,     0,   366,     0,     0,   896,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   366,     0,
       0,     0,   531,   367,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
     380,   381,   382,     0,     0,   367,   366,   702,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   366,   367,     0,     0,   708,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   368,
     369,   370,   371,   372,   373,   374,   375,   376,   377,   378,
     379,   380,   381,   382,     0,   366,     0,     0,   718,   367,
       0,     0,   730,     0,     0,     0,     0,     0,     0,     0,
     366,     0,     0,     0,     0,     0,     0,   368,   369,   370,
     371,   372,   373,   374,   375,   376,   377,   378,   379,   380,
     381,   382,   367,     0,     0,     0,   894,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   367,     0,     0,
       0,     0,     0,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,     0,     0,
       0,     0,   895,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   368,   369,   370,   371,
     372,   373,   374,   375,   376,   377,   378,   379,   380,   381,
     382,   368,   369,   370,   371,   372,   373,   374,   375,   376,
     377,   378,   379,   380,   381,   382
};

static const yytype_int16 yycheck[] =
{
       4,   326,   311,     7,    23,   430,    23,   331,   405,   333,
     334,    20,   242,   337,   338,   620,   784,   341,   342,    23,
     438,    25,     5,   441,   442,   443,   444,   445,   446,   392,
     393,    20,     5,    25,     9,     8,    29,   642,   539,    43,
      50,     0,    38,    34,     5,   616,    14,    46,   262,   620,
      55,    13,    14,   267,    55,   269,     9,    47,     5,    33,
       5,     8,    89,    78,    32,    13,    14,    33,    23,   110,
      74,    75,    76,    77,     5,     6,    88,     8,     5,     6,
      77,     8,    88,    14,    26,    13,    14,    14,    65,    77,
      56,    50,     5,     6,    84,     5,     6,    33,     8,    56,
      15,    14,    64,    15,    14,     5,     6,    62,     8,    33,
      72,     5,     6,    64,    14,    65,    66,   158,    77,    55,
      14,    72,    64,   158,    79,   160,    65,    93,   116,   107,
     735,   158,   128,   107,    49,   156,    93,    49,   135,   124,
     135,   153,    97,   158,    94,   155,   120,   153,   116,   135,
     866,   150,   107,   158,    71,   656,    64,   158,   149,     0,
     150,   151,   152,   158,    72,   158,   149,   772,   157,   158,
      55,   776,   158,   142,   157,   572,   149,   181,   182,   183,
     184,   156,   186,   187,   188,   189,   311,   312,   149,   193,
     194,   195,   196,   197,   408,   187,   155,   768,   769,   161,
     325,   772,   149,   156,   149,   419,   110,    21,   977,   142,
     157,   574,   157,   161,   142,   156,   984,   124,   149,    18,
      19,    26,   149,   142,   143,   156,    19,    26,   232,   156,
      44,  1000,   236,   161,   464,   156,   149,   953,   242,   149,
     564,   250,   156,   156,   142,   249,   124,   251,   252,   149,
      47,   967,   256,    27,   859,   149,    18,    19,   472,    64,
     156,   977,   138,   139,    26,    64,    98,   138,   139,   273,
     102,   290,   156,   290,   108,   156,   110,   109,    52,   113,
     405,   157,   156,   999,  1000,    89,   290,    84,     5,     6,
     157,   158,   157,   158,   298,    69,    70,   157,   158,   157,
     158,   305,    64,   156,   909,   157,   158,   157,   158,   156,
      72,   157,   158,   438,   157,   158,   441,   442,   443,   444,
     445,   446,   110,   448,    77,   450,   451,   452,   453,   454,
     455,   156,   457,   458,   157,   158,   156,   142,   143,   144,
     145,   146,   147,   117,   156,   763,   764,   156,   153,   157,
     158,   148,   149,   150,   151,   152,   156,   361,   483,   363,
     778,   138,   139,   781,   489,   157,   158,   157,   158,   583,
     679,   585,   157,   158,   157,   158,   157,   158,   157,   158,
     142,   143,   144,   145,   146,   147,    47,   156,   392,   393,
     156,   153,   157,   158,   157,   158,    16,   157,   158,   157,
     158,   405,   157,   158,   156,   424,   156,   426,   156,   534,
     429,   430,   416,   157,   158,   434,   435,   434,   422,   423,
     424,   156,   426,    84,   156,   429,   430,    16,   131,   826,
     434,   435,   157,   158,   156,   228,   156,   230,   231,   157,
     158,   460,    31,   157,   158,    65,    35,   572,   157,   158,
     157,   158,    41,   157,   158,   780,   460,   461,   467,   156,
     464,   156,    82,   157,   158,   156,   156,   156,    57,   473,
     474,   156,    92,   156,    94,    95,    65,   496,   156,   496,
     905,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   496,    82,     5,   620,   116,   120,   100,   123,
     120,   105,   122,    92,    47,    94,    95,    55,   512,   302,
     127,   127,   157,   133,   639,   114,   157,   642,   156,    47,
     156,   156,     5,   112,   649,    10,   156,   116,   532,   142,
     534,   120,   121,   122,    57,   142,   142,   330,    57,    73,
     116,    84,   116,   336,   133,     8,   339,   340,   157,   150,
     343,   344,   157,   156,   679,   136,    84,   157,   683,   156,
     156,   870,   156,    36,    36,   358,   107,   158,   572,   362,
     574,   575,    20,   366,   367,   368,   369,   370,   371,   372,
     373,   374,   375,   376,   377,   378,   379,   380,   381,   382,
     383,   158,   596,     8,     8,     8,     8,   142,   391,   157,
     162,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     735,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   949,   158,    88,   149,     8,
     156,    76,     9,   142,   158,   111,     5,   111,   763,   764,
      27,    28,     8,   157,   157,   157,   139,   772,   773,   157,
     157,   776,   157,   778,    47,   158,   781,     8,   139,   139,
     969,   665,    88,   100,   156,    52,   670,   671,   672,    47,
     156,   796,   139,   466,   156,   130,  1001,   142,   682,    90,
     157,   114,    69,    70,   114,  1009,   156,   139,    75,   157,
     108,    84,   142,   818,    58,   157,     5,   138,    85,    86,
     142,   826,   142,   142,     8,   139,    84,   139,    29,   158,
      78,   136,   505,   156,     8,     8,     8,     8,     5,    64,
     158,   157,    98,     8,     8,   156,   730,   852,   137,   156,
     117,   126,   857,   157,   859,   157,   529,   530,   139,   156,
     744,   745,    90,    29,    58,   870,    61,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     779,   157,   142,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   779,     8,   158,     3,    29,
      78,   156,    90,   157,   909,   158,   157,   157,   142,     5,
      29,   810,   811,   810,     8,   158,   158,   158,   158,   156,
       5,   157,   303,   505,   975,   727,   810,   811,   819,   362,
     955,   811,   956,   967,   818,   745,   532,   869,   961,   701,
     818,   575,   826,   938,   994,   679,   683,   779,   679,    21,
     385,   835,   839,   372,   959,   839,   662,   359,   325,    -1,
     664,    -1,    -1,    -1,   969,    -1,    -1,   866,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   866,    -1,    -1,   869,    -1,    -1,    -1,   662,
      -1,   664,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   905,    -1,   892,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   905,    -1,    -1,    -1,   698,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   712,
      -1,   714,    -1,   942,   717,   942,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   953,    -1,   955,    -1,   942,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   950,    -1,   967,   953,
      -1,   955,    -1,    -1,    -1,    -1,    -1,   961,   977,    -1,
      -1,    -1,    -1,   967,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   975,    -1,   977,    -1,    -1,    -1,    -1,    -1,    -1,
     999,  1000,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,
       6,    -1,     8,     9,    10,   999,  1000,    -1,    14,    15,
      16,    17,    18,    19,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,   819,    43,    44,    45,
      46,    -1,    48,    49,    -1,    -1,    52,    53,    54,    -1,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      -1,    67,    68,    69,    70,    71,    -1,    73,    -1,    75,
      76,    77,    -1,    -1,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,   105,
     106,   107,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,    -1,
     126,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
     136,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,   150,    -1,    -1,   153,    -1,    -1,
     156,    -1,    -1,   159,     3,     4,     5,     6,    -1,     8,
       9,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    -1,    -1,    52,    53,    54,    -1,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    -1,    67,    68,
      69,    70,    71,    -1,    73,    -1,    75,    76,    77,    -1,
      -1,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,    -1,   102,   103,   104,   105,   106,   107,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,   122,   123,   124,    -1,   126,   127,   128,
     129,   130,   131,    -1,   133,   134,   135,   136,   137,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     149,    -1,    -1,    -1,   153,    -1,    -1,   156,   157,    -1,
     159,     3,     4,     5,     6,    -1,     8,     9,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    -1,    -1,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    -1,    67,    68,    69,    70,    71,
      -1,    73,    -1,    75,    76,    77,    -1,    -1,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,    -1,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,    -1,   126,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,   136,   137,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,
      -1,   153,    -1,    -1,   156,   157,    -1,   159,     3,     4,
       5,     6,    -1,     8,     9,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    -1,    -1,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    -1,    67,    68,    69,    70,    71,    -1,    73,    -1,
      75,    76,    77,    -1,    -1,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
     105,   106,   107,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,   122,   123,   124,
      -1,   126,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,   136,   137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   149,   150,    -1,    -1,   153,    -1,
      -1,   156,    -1,    -1,   159,     3,     4,     5,     6,    -1,
       8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    -1,    -1,    52,    53,    54,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    -1,    67,
      68,    69,    70,    71,    -1,    73,    -1,    75,    76,    77,
      -1,    -1,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,    -1,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,    -1,   126,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,   136,   137,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   149,   150,    -1,    -1,   153,    -1,    -1,   156,    -1,
      -1,   159,     3,     4,     5,     6,    -1,     8,     9,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    -1,
      -1,    52,    53,    54,    -1,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    -1,    67,    68,    69,    70,
      71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
      -1,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,   122,   123,   124,    -1,   126,   127,   128,   129,   130,
     131,    -1,   133,   134,   135,   136,   137,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,    -1,
      -1,    -1,   153,    -1,    -1,   156,    -1,    -1,   159,     3,
       4,     5,     6,    -1,     8,     9,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    -1,    -1,    52,    53,
      54,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    -1,    67,    68,    69,    70,    71,    -1,    73,
      -1,    75,    76,    77,    -1,    -1,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,    -1,   102,   103,
     104,   105,   106,   107,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,    -1,   126,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,   136,   137,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   149,    -1,    -1,    -1,   153,
      -1,    -1,   156,   157,    -1,   159,     3,     4,     5,     6,
      -1,     8,     9,    -1,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    -1,    -1,    52,    53,    54,    -1,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    -1,
      67,    68,    69,    70,    71,    -1,    73,    -1,    75,    76,
      77,    -1,    -1,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,    -1,   102,   103,   104,   105,   106,
     107,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,   122,   123,   124,    -1,   126,
     127,   128,   129,   130,   131,    -1,   133,   134,   135,   136,
     137,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   149,    -1,    -1,    -1,   153,    -1,    -1,   156,
      -1,    -1,   159,     3,     4,     5,     6,    -1,     8,     9,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      -1,    -1,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    -1,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,   136,   137,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      -1,    -1,    -1,   153,    -1,    -1,   156,    -1,    -1,   159,
       3,     4,     5,     6,    -1,     8,     9,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    -1,    -1,    52,
      53,    54,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    -1,    67,    68,    69,    70,    71,    -1,
      73,    -1,    75,    76,    77,    -1,    -1,    80,    81,    82,
      83,    -1,    85,    86,    87,    -1,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,    -1,   102,
     103,   104,   105,   106,   107,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,   122,
     123,   124,    -1,   126,   127,   128,   129,   130,   131,    -1,
     133,   134,   135,   136,   137,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   149,     3,     4,     5,
     153,    -1,    -1,   156,    -1,    -1,   159,    -1,    -1,    15,
      16,    17,    18,    19,    -1,    21,    22,    23,    24,    25,
      26,    27,    28,    -1,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    -1,    43,    44,    45,
      46,    -1,    48,    49,    50,    -1,    52,    53,    54,    -1,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      -1,    67,    68,    69,    70,    71,    -1,    73,    -1,    75,
      76,    77,    -1,    -1,    80,    81,    82,    83,    -1,    85,
      86,    87,    -1,    89,    -1,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,    -1,   102,   103,   104,   105,
     106,   107,    -1,   109,   110,   111,   112,   113,   114,   115,
     116,   117,    -1,   119,   120,   121,   122,   123,   124,    -1,
     126,   127,   128,   129,   130,   131,    -1,   133,   134,   135,
     136,   137,    -1,     3,     4,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   149,    -1,    15,    16,    17,    18,    19,
     156,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    -1,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    -1,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,    -1,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,   136,   137,    -1,     3,
      -1,     5,    -1,    -1,     8,    -1,    -1,    -1,    -1,   149,
      -1,    15,    16,    17,    18,    19,   156,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    -1,    -1,    52,    53,
      54,    -1,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    65,    -1,    67,    68,    69,    70,    71,    -1,    73,
      -1,    75,    76,    77,    -1,    -1,    80,    81,    82,    83,
      -1,    85,    86,    87,    -1,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,    -1,   102,   103,
     104,   105,   106,   107,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,   122,   123,
     124,    -1,   126,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,   136,   137,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,
      18,    19,   156,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    -1,    -1,    52,    53,    54,    -1,    56,    57,
      58,    59,    60,    61,    62,    -1,    -1,    65,    -1,    67,
      68,    69,    70,    71,    -1,    73,    -1,    75,    76,    77,
       0,    -1,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,    47,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,    47,   126,   127,
     128,   129,   130,   131,    -1,   133,   134,   135,   136,   137,
      84,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   156,    -1,
      -1,    -1,    -1,    -1,    84,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,    -1,
      -1,    -1,    -1,   157,   158,    -1,    -1,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,     3,    -1,     5,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      -1,    51,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    -1,    -1,    65,    -1,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,    -1,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,   136,   137,     3,     4,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      15,    16,    17,    18,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    -1,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    -1,    67,    68,    69,    70,    71,    -1,    73,    -1,
      75,    76,    77,    -1,    -1,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,    -1,   102,   103,   104,
     105,   106,   107,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,   122,   123,   124,
      -1,   126,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,   136,   137,     3,    -1,     5,    -1,    -1,     8,    -1,
      -1,    -1,    -1,    -1,   149,    15,    16,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      -1,    -1,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    -1,    -1,    65,    -1,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,    -1,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,   136,   137,     3,    -1,
       5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   149,
      15,    16,    17,    18,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    -1,    -1,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      65,    -1,    67,    68,    69,    70,    71,    -1,    73,    -1,
      75,    76,    77,    -1,    -1,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,    -1,   102,   103,   104,
     105,   106,   107,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,   122,   123,   124,
      -1,   126,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,   136,   137,     3,    -1,     5,     6,    -1,     8,    -1,
      -1,    -1,    -1,    -1,   149,    15,    16,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      -1,    -1,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    -1,    -1,    65,    -1,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    85,    86,    87,    88,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,    -1,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,   136,   137,     3,     4,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      15,    16,    17,    18,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    50,    -1,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    -1,    67,    68,    69,    70,    71,    -1,    73,    -1,
      75,    76,    77,    -1,    -1,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,    -1,   102,   103,   104,
     105,   106,   107,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,   122,   123,   124,
      -1,   126,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,   136,   137,     3,     4,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      50,    -1,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    -1,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,    -1,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,    -1,   133,   134,   135,   136,   137,     3,    -1,
       5,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,
      15,    16,    17,    18,    19,    -1,    21,    22,    23,    24,
      25,    26,    27,    28,    -1,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    -1,    43,    44,
      45,    46,    -1,    48,    49,    -1,    -1,    52,    53,    54,
      -1,    56,    57,    58,    59,    60,    61,    62,    -1,    -1,
      65,    -1,    67,    68,    69,    70,    71,    -1,    73,    -1,
      75,    76,    77,    -1,    -1,    80,    81,    82,    83,    -1,
      85,    86,    87,    -1,    89,    -1,    91,    92,    93,    94,
      95,    96,    97,    98,    -1,   100,    -1,   102,   103,   104,
     105,   106,   107,    -1,   109,   110,   111,   112,   113,   114,
     115,   116,   117,    -1,   119,   120,   121,   122,   123,   124,
      -1,   126,   127,   128,   129,   130,   131,    -1,   133,   134,
     135,   136,   137,     3,    -1,     5,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      -1,    -1,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    -1,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,    -1,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,     3,   133,   134,   135,   136,   137,    -1,    -1,
      -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    -1,
      -1,    52,    53,    54,    -1,    56,    57,    58,    59,    60,
      61,    62,    -1,    64,    65,    -1,    67,    68,    69,    70,
      71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
      -1,   102,   103,   104,   105,   106,   107,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,   122,   123,   124,    -1,   126,   127,   128,   129,   130,
     131,     3,   133,   134,   135,   136,   137,    -1,    -1,    -1,
      -1,    -1,    -1,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    -1,    -1,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      62,    -1,    -1,    65,    -1,    67,    68,    69,    70,    71,
      -1,    73,    -1,    75,    76,    77,    -1,    -1,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,    -1,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
     122,   123,   124,    -1,   126,   127,   128,   129,   130,   131,
      -1,   133,   134,   135,   136,   137,     3,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,
      17,    18,    19,    -1,    21,    22,    23,    24,    25,    26,
      27,    28,    -1,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    -1,    43,    44,    45,    46,
      -1,    48,    49,    -1,    -1,    52,    53,    54,    -1,    56,
      57,    58,    59,    60,    61,    62,    -1,    -1,    65,    -1,
      67,    68,    69,    70,    71,    -1,    73,    -1,    75,    76,
      77,    -1,    -1,    80,    81,    82,    83,    -1,    85,    86,
      87,    -1,    89,    -1,    91,    92,    93,    94,    95,    96,
      97,    98,    -1,   100,    -1,   102,   103,   104,   105,   106,
     107,    -1,   109,   110,   111,   112,   113,   114,   115,   116,
     117,    -1,   119,   120,   121,   122,   123,   124,    -1,   126,
     127,   128,   129,   130,   131,     3,   133,   134,   135,   136,
     137,    -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,
      18,    19,    -1,    21,    22,    23,    24,    25,    26,    27,
      28,    -1,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    -1,    43,    44,    45,    46,    -1,
      48,    49,    -1,    -1,    52,    53,    54,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    -1,    67,
      68,    69,    70,    71,    -1,    73,    -1,    75,    76,    77,
      -1,    -1,    80,    81,    82,    83,    -1,    85,    86,    87,
      -1,    89,    -1,    91,    92,    93,    94,    95,    96,    97,
      98,    -1,   100,    -1,   102,   103,   104,   105,   106,   107,
      -1,   109,   110,   111,   112,   113,   114,   115,   116,   117,
      -1,   119,   120,   121,   122,   123,   124,    -1,   126,   127,
     128,   129,   130,   131,     3,   133,   134,   135,   136,   137,
      -1,    -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,
      19,    -1,    21,    22,    23,    24,    25,    26,    27,    28,
      -1,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    -1,    43,    44,    45,    46,    -1,    48,
      49,    -1,    -1,    52,    53,    54,    -1,    56,    57,    58,
      59,    60,    61,    62,    -1,    -1,    65,    -1,    67,    68,
      69,    70,    71,    -1,    73,    -1,    75,    76,    77,    78,
      -1,    80,    81,    82,    83,    -1,    85,    86,    87,    -1,
      89,    -1,    91,    92,    93,    94,    95,    96,    97,    98,
      -1,   100,    -1,   102,   103,   104,   105,   106,   107,    -1,
     109,   110,   111,   112,   113,   114,   115,   116,   117,    -1,
     119,   120,   121,   122,   123,   124,    -1,   126,   127,   128,
     129,   130,   131,     3,   133,   134,   135,   136,   137,    -1,
      -1,    -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,
      -1,    21,    22,    23,    24,    25,    26,    27,    28,    -1,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    -1,    43,    44,    45,    46,    -1,    48,    49,
      -1,    -1,    52,    53,    54,    -1,    56,    57,    58,    59,
      60,    61,    62,    -1,    -1,    65,    -1,    67,    68,    69,
      70,    71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,
      80,    81,    82,    83,    -1,    85,    86,    87,    -1,    89,
      -1,    91,    92,    93,    94,    95,    96,    97,    98,    -1,
     100,    -1,   102,   103,   104,   105,   106,   107,    -1,   109,
     110,   111,   112,   113,   114,   115,   116,   117,    -1,   119,
     120,   121,   122,   123,   124,    -1,   126,   127,   128,   129,
     130,   131,     3,   133,   134,   135,   136,   137,    -1,    -1,
      -1,    -1,    -1,    -1,    15,    16,    17,    18,    19,    -1,
      21,    22,    23,    24,    25,    26,    27,    28,    -1,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    -1,    43,    44,    45,    46,    -1,    48,    49,    -1,
      -1,    52,    53,    54,    -1,    56,    57,    58,    59,    60,
      61,    62,    -1,    -1,    65,    -1,    67,    68,    69,    70,
      71,    -1,    73,    -1,    75,    76,    77,    -1,    -1,    80,
      81,    82,    83,    -1,    85,    86,    87,    -1,    89,    -1,
      91,    92,    93,    94,    95,    96,    97,    98,    -1,   100,
      -1,   102,   103,   104,   105,   106,   107,    -1,   109,   110,
     111,   112,   113,   114,   115,   116,   117,    -1,   119,   120,
     121,   122,   123,   124,    -1,   126,   127,   128,   129,   130,
     131,     3,   133,   134,   135,   136,   137,    -1,    10,    -1,
      -1,    -1,    -1,    15,    16,    17,    18,    19,    -1,    21,
      22,    23,    24,    25,    26,    27,    28,    -1,    30,    31,
      32,    33,    -1,    35,    36,    37,    38,    39,    40,    41,
      -1,    43,    44,    45,    46,    -1,    48,    49,    -1,    -1,
      52,    53,    54,    -1,    56,    57,    58,    59,    60,    61,
      62,    -1,    -1,    65,    -1,    67,    68,    69,    70,    71,
      -1,    73,    -1,    75,    76,    77,    -1,    -1,    80,    81,
      82,    83,    -1,    85,    86,    87,    -1,    89,    -1,    91,
      92,    93,    94,    95,    96,    97,    98,    -1,   100,    -1,
     102,   103,   104,   105,   106,   107,    -1,   109,   110,   111,
     112,   113,   114,   115,   116,   117,    -1,   119,   120,   121,
     122,   123,    -1,    -1,   126,   127,   128,   129,   130,   131,
       3,   133,   134,   135,   136,   137,     9,    -1,    -1,    -1,
      -1,    -1,    15,    16,    17,    18,    19,    -1,    21,    22,
      23,    24,    25,    26,    27,    28,    -1,    30,    31,    32,
      33,    -1,    35,    36,    37,    38,    39,    40,    41,    -1,
      43,    44,    45,    46,    -1,    48,    49,    -1,    -1,    52,
      53,    54,    -1,    56,    57,    58,    59,    60,    61,    62,
      -1,    -1,    65,    -1,    67,    68,    69,    70,    71,    -1,
      73,    -1,    75,    76,    77,    -1,    -1,    80,    81,    82,
      83,    -1,    85,    86,    -1,    -1,    89,    -1,    91,    92,
      93,    94,    95,    96,    97,    98,    -1,   100,    -1,   102,
     103,   104,   105,   106,   107,    -1,   109,   110,   111,   112,
     113,   114,   115,   116,   117,    -1,   119,   120,   121,   122,
     123,   124,    -1,   126,   127,   128,   129,   130,   131,     3,
     133,   134,   135,   136,   137,    -1,    10,    -1,    -1,    -1,
      -1,    15,    16,    17,    18,    19,    -1,    21,    22,    23,
      24,    25,    26,    27,    28,    -1,    30,    31,    32,    33,
      -1,    35,    36,    37,    38,    39,    40,    41,    -1,    43,
      44,    45,    46,    -1,    48,    49,    -1,    47,    52,    53,
      54,    -1,    56,    57,    58,    59,    60,    61,    62,    -1,
      -1,    65,    -1,    67,    68,    69,    70,    71,    -1,    73,
      -1,    75,    76,    77,    -1,    -1,    80,    81,    82,    83,
      -1,    85,    86,    87,    84,    89,    -1,    91,    92,    93,
      94,    95,    96,    97,    98,    -1,   100,    -1,   102,   103,
     104,   105,   106,   107,    -1,   109,   110,   111,   112,   113,
     114,   115,   116,   117,    -1,   119,   120,   121,   122,   123,
      47,    -1,   126,   127,   128,   129,   130,   131,    -1,   133,
     134,   135,   136,   137,    -1,    -1,    -1,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,    17,    -1,    -1,    -1,    84,    22,    -1,
      -1,    25,   162,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    -1,    -1,    37,    -1,    -1,    40,    -1,    42,    43,
      44,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    53,
      -1,    47,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    68,    -1,    -1,    -1,    -1,    -1,
      74,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,    47,    91,    84,    -1,
     157,   158,    -1,    -1,    -1,    -1,    -1,   101,    -1,   103,
      -1,    -1,   106,    -1,   108,    -1,   110,    -1,    -1,   113,
      -1,   115,    -1,    -1,   118,    -1,    -1,    -1,    -1,    -1,
      47,    -1,   126,    84,    -1,   129,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,    84,    47,    -1,
      -1,    -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,    47,    -1,    -1,    84,    -1,   158,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,    -1,    47,    -1,    84,
      -1,   158,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,    84,    -1,    47,    -1,    -1,   158,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,    47,    -1,
      -1,    -1,   157,    84,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,    -1,    -1,    84,    47,   157,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,    47,    84,    -1,    -1,   157,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,    -1,    47,    -1,    -1,   157,    84,
      -1,    -1,    54,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    -1,    -1,    -1,    -1,    -1,    -1,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,    84,    -1,    -1,    -1,   157,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    84,    -1,    -1,
      -1,    -1,    -1,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,    -1,    -1,
      -1,    -1,   157,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    17,    22,    25,    30,    37,    40,    42,    43,    44,
      45,    49,    53,    68,    74,    91,   101,   103,   106,   108,
     110,   113,   115,   118,   126,   129,   164,   165,   168,   169,
     170,   171,   178,   222,   227,   228,   233,   234,   235,   236,
     247,   248,   257,   259,   260,   261,   262,   266,   267,   272,
     273,   274,   277,   279,   280,   282,   283,   284,   285,   286,
     287,   291,   292,   294,   295,   296,   297,   311,   312,   313,
     314,   316,   318,   319,    33,   107,   120,    65,     3,    15,
      16,    17,    18,    19,    21,    22,    23,    24,    25,    26,
      27,    28,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    43,    44,    45,    46,    48,    49,
      52,    53,    54,    56,    57,    58,    59,    60,    61,    62,
      65,    67,    68,    69,    70,    71,    73,    75,    76,    77,
      80,    81,    82,    83,    85,    86,    87,    89,    91,    92,
      93,    94,    95,    96,    97,    98,   100,   102,   103,   104,
     105,   106,   107,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   119,   120,   121,   122,   123,   124,   126,   127,
     128,   129,   130,   131,   133,   134,   135,   136,   137,   166,
     167,    33,    56,    93,   167,   315,    33,    55,    56,    93,
      23,    62,    79,    97,   107,    33,    65,    65,    66,    94,
       3,     4,     5,     6,     8,     9,    10,    14,    18,    19,
      24,    27,    39,    48,    52,    59,    60,    63,    64,    67,
      70,    81,    83,    96,    99,   104,   119,   134,   149,   150,
     153,   156,   159,   167,   179,   180,   182,   214,   215,   218,
     288,   289,   290,   298,   299,   302,   303,    10,    31,    33,
      57,    65,    87,   112,   166,   275,    16,    31,    35,    41,
      57,    65,    82,    92,    94,    95,   112,   116,   120,   121,
     122,   133,   224,   225,   275,   124,     4,     5,    18,    19,
      27,    39,    48,    50,    59,    63,    70,    99,   134,   149,
     156,   167,   188,   189,   190,   191,   192,   299,   107,   167,
     183,     0,    50,   155,   309,    71,   167,   167,   167,   167,
     167,   156,   167,   167,   167,     5,     8,   167,   229,   167,
     183,   167,   167,   167,   167,   167,   167,   167,    55,   156,
     156,   156,   156,   156,   156,   156,   156,   156,   156,   156,
     156,   156,   156,   156,   156,   156,     3,    81,    83,   214,
     214,   214,    64,   167,   219,   220,    13,    14,   161,   300,
     301,    55,   158,    20,   167,   181,    47,    84,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   156,    78,   158,   206,   207,   181,    64,
      72,   142,   142,   110,   167,     9,   166,   167,     5,     6,
       8,    88,   167,   231,   232,   142,   124,     8,   116,   167,
     110,    77,   223,   223,   223,   223,    89,   208,   209,   116,
     167,   131,   156,   156,   156,   156,   156,   156,   156,   156,
     156,   156,     5,   188,   138,   139,    18,    19,    26,    64,
      72,   142,   143,   144,   145,   146,   147,   153,    26,    64,
     142,   143,   144,   145,   146,   147,   153,   142,   143,   167,
     110,   158,   214,   306,   307,   308,   108,   110,   113,   169,
     167,   120,   258,    15,    49,   100,    15,    49,   123,     6,
       8,    14,   149,   156,   192,   193,   243,   249,   250,   156,
     243,   253,   254,   317,   105,   127,   135,   185,   127,   317,
     208,    55,   310,   114,     8,   156,   157,   214,   216,   217,
     214,   216,    46,   150,   216,   216,   157,   214,   216,   216,
     214,   214,   157,   216,   216,   214,   214,   157,   156,   156,
     156,   157,   158,   160,   142,     8,   214,   301,   156,   183,
     180,   214,   167,   214,   214,   214,   214,   214,   214,   214,
     303,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     214,   214,     5,   289,   156,    88,   153,   214,   231,   231,
      57,   142,   142,    57,    34,   149,    51,    88,   125,   192,
     229,   230,    73,   116,   223,   116,     8,   167,   210,   211,
     223,    14,    32,   116,   226,    77,   135,   268,   269,   167,
     167,   167,   299,   150,   299,   157,   157,   299,   167,   298,
     299,   157,   157,   188,   188,   156,   156,   192,   193,     9,
     156,    88,   153,     8,   192,   193,     8,   192,   193,   192,
     193,   192,   193,   192,   193,   192,   193,    18,    19,    26,
      64,   192,   156,   192,   192,   192,   192,   192,   192,    26,
      64,   192,   192,   136,   293,   167,   263,   264,   299,   167,
     181,    29,   158,   304,   305,   156,   237,   223,   167,   167,
      36,    36,   107,     6,     8,   157,   192,   194,   251,   158,
     252,    20,   255,   158,    27,    52,    69,    70,   117,   278,
       8,    80,   186,   187,   188,     8,     8,     8,   108,   171,
     157,   158,   157,   157,   167,   157,   157,   157,   157,   157,
     157,   157,   158,   157,   158,   157,   157,   158,   157,   214,
     214,   220,   167,   192,   221,   162,   162,   175,   184,   185,
      54,   158,   216,    88,     8,   156,   192,   229,     9,   231,
     232,    76,   223,   223,   142,   158,   111,     5,   111,     8,
     167,   270,   271,   157,   157,   157,   157,   157,   157,   158,
       8,   195,   195,   139,   139,   194,   195,    88,   156,   156,
     192,     9,   156,   139,   194,   192,   156,   100,   142,   158,
     185,   142,   306,    90,   202,   203,   308,    63,   167,   238,
     239,   130,   167,   167,   167,   157,   158,   157,   158,   243,
     250,   253,   157,    78,   167,   256,   254,   114,   114,   156,
     139,   139,   157,   217,   157,   214,   214,   214,   142,   108,
     178,    58,   196,   167,     5,   157,   142,   194,   142,    98,
     102,   109,   276,     5,     8,   156,   167,   211,   142,   138,
       8,   157,   158,   157,   192,   193,   192,   193,   157,   157,
     195,   195,   139,   194,   195,   192,   157,   139,   194,   156,
     192,   193,   264,   208,   192,   193,    29,   206,   157,   158,
     156,   240,   241,    27,    28,    52,    69,    70,    75,    85,
      86,   117,   265,   136,   281,   192,     8,     8,     8,     8,
     188,   187,   158,   172,   157,   157,   158,   221,   179,   157,
       5,   197,   137,   200,   201,    64,   192,   229,   157,   156,
      38,   128,    98,   167,   212,   213,   156,     8,   271,   157,
       8,   157,   157,   192,   157,   157,   192,   157,   157,   194,
      96,   190,   204,   205,   238,   242,   243,    89,   158,   244,
     126,   157,   139,     5,    63,   167,   173,   174,   157,   156,
      55,    90,   176,    29,    58,    61,   199,   298,   194,   142,
     157,   158,     8,   157,   156,    21,    44,   158,   157,   158,
       3,   245,   246,   241,   188,   158,   216,    29,    78,   177,
     190,   198,    90,   189,   202,   157,   157,   192,   213,   157,
     157,   205,   243,   142,   158,   174,   157,   204,     5,   158,
      29,   206,     8,   246,   158,   158,   190,   204,   208,   156,
       5,   216,   157,   157
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   163,   164,   164,   164,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   165,   165,   165,   165,
     165,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   166,
     166,   166,   166,   166,   166,   166,   166,   166,   166,   167,
     167,   167,   167,   168,   168,   168,   169,   169,   169,   170,
     170,   171,   171,   172,   172,   173,   173,   174,   174,   174,
     175,   176,   177,   177,   177,   178,   179,   179,   180,   180,
     181,   181,   181,   182,   182,   182,   182,   182,   182,   182,
     182,   182,   183,   183,   184,   184,   185,   186,   186,   186,
     186,   186,   187,   188,   188,   188,   188,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   189,   189,   189,   189,   189,   189,   189,   189,   189,
     189,   190,   190,   190,   190,   190,   190,   190,   190,   190,
     190,   190,   191,   191,   192,   192,   193,   193,   193,   194,
     194,   195,   195,   196,   196,   197,   197,   198,   198,   199,
     199,   200,   200,   201,   202,   202,   203,   203,   204,   204,
     205,   205,   205,   206,   206,   207,   207,   208,   208,   209,
     210,   210,   211,   211,   211,   211,   211,   211,   212,   212,
     213,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     214,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     214,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     214,   214,   214,   214,   215,   215,   215,   215,   215,   215,
     215,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     216,   216,   217,   217,   218,   218,   218,   219,   219,   220,
     220,   221,   221,   222,   223,   223,   224,   224,   224,   224,
     224,   224,   224,   224,   224,   224,   224,   224,   224,   224,
     225,   225,   226,   226,   227,   227,   227,   227,   227,   227,
     227,   228,   228,   228,   228,   228,   228,   229,   229,   230,
     230,   230,   231,   231,   232,   232,   232,   232,   232,   233,
     233,   233,   234,   234,   235,   236,   236,   237,   237,   238,
     238,   239,   239,   240,   240,   241,   242,   242,   243,   243,
     243,   243,   243,   244,   244,   245,   245,   246,   247,   248,
     249,   249,   250,   250,   251,   251,   252,   252,   253,   253,
     254,   255,   255,   256,   256,   257,   258,   258,   259,   259,
     260,   261,   262,   263,   263,   264,   264,   264,   264,   264,
     264,   265,   265,   265,   265,   265,   265,   265,   265,   265,
     266,   266,   266,   266,   266,   267,   267,   268,   268,   269,
     270,   270,   271,   272,   273,   274,   275,   275,   275,   276,
     276,   276,   276,   277,   278,   278,   278,   278,   278,   279,
     280,   281,   281,   282,   283,   284,   285,   286,   287,   288,
     288,   289,   290,   291,   292,   293,   293,   294,   295,   296,
     297,   298,   298,   299,   300,   300,   301,   301,   301,   301,
     302,   302,   303,   304,   304,   305,   306,   307,   308,   308,
     309,   310,   310,   311,   312,   313,   314,   315,   315,   315,
     315,   316,   317,   317,   318,   319
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     2,     1,     1,     1,     1,
       8,     1,     9,     0,     2,     1,     3,     1,     1,     1,
       0,     3,     0,     2,     4,    11,     1,     3,     1,     2,
       0,     1,     2,     1,     4,     4,     4,     4,     4,     4,
       3,     5,     1,     3,     0,     1,     2,     1,     1,     3,
       3,     5,     4,     1,     3,     3,     3,     3,     3,     5,
       6,     5,     6,     5,     6,     5,     6,     3,     4,     5,
       6,     3,     3,     3,     3,     3,     3,     5,     5,     5,
       3,     3,     3,     3,     3,     3,     3,     4,     3,     3,
       3,     3,     5,     6,     5,     6,     3,     3,     3,     3,
       6,     1,     1,     4,     3,     3,     1,     1,     4,     4,
       4,     3,     4,     4,     1,     2,     1,     2,     1,     1,
       3,     1,     3,     0,     4,     0,     1,     1,     3,     0,
       2,     0,     1,     5,     0,     1,     3,     5,     1,     3,
       1,     2,     2,     0,     1,     2,     4,     0,     1,     2,
       1,     3,     1,     3,     3,     5,     6,     3,     1,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     1,
       1,     1,     3,     4,     4,     4,     5,     4,     4,     4,
       4,     3,     6,     6,     3,     8,    14,     3,     4,     4,
       1,     3,     1,     1,     1,     1,     1,     3,     5,     1,
       1,     1,     1,     2,     0,     2,     1,     2,     2,     3,
       1,     1,     1,     2,     4,     4,     3,     4,     4,     3,
       1,     1,     0,     2,     4,     4,     4,     3,     5,     4,
       4,     7,     5,     5,     9,     7,     7,     1,     1,     1,
       1,     1,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     2,     7,     1,     1,     0,     3,     1,
       1,     1,     3,     1,     3,     3,     1,     3,     1,     1,
       1,     3,     2,     0,     2,     1,     3,     3,     4,     6,
       1,     3,     1,     3,     1,     3,     0,     2,     1,     3,
       3,     0,     1,     1,     1,     4,     0,     1,     1,     1,
       3,     3,     6,     1,     3,     3,     3,     5,     4,     3,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       7,     6,     4,     5,     5,     4,     5,     0,     1,     2,
       1,     3,     3,     2,     3,     6,     0,     1,     1,     2,
       2,     2,     1,     7,     1,     1,     1,     1,     1,     3,
       7,     0,     2,     3,     3,     2,     2,     2,     3,     1,
       3,     2,     1,     2,     4,     0,     2,     4,     7,     5,
       5,     1,     1,     2,     1,     2,     1,     1,     3,     3,
       3,     3,     1,     0,     2,     1,     2,     1,     1,     3,
       5,     0,     2,     4,     2,     2,     2,     0,     1,     2,
       2,     4,     0,     1,     4,     3
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (pParser, YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, pParser); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, SqlParser_c * pParser)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  YYUSE (pParser);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, SqlParser_c * pParser)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep, pParser);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule, SqlParser_c * pParser)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              , pParser);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pParser); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, SqlParser_c * pParser)
{
  YYUSE (yyvaluep);
  YYUSE (pParser);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (SqlParser_c * pParser)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, pParser);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 198 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->PushQuery(); }
#line 3216 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 143:
#line 281 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->PushQuery(); }
#line 3222 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 144:
#line 282 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->PushQuery(); }
#line 3228 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 145:
#line 283 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->PushQuery(); }
#line 3234 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 150:
#line 295 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			assert ( pParser->m_pStmt->m_eStmt==STMT_SELECT ); // set by table argument
			pParser->ToString ( pParser->m_pStmt->m_sTableFunc, (yyvsp[-6]) );
		}
#line 3243 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 152:
#line 305 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			assert ( pParser->m_pStmt->m_eStmt==STMT_SELECT ); // set by subselect
		}
#line 3251 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 155:
#line 317 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToString ( pParser->m_pStmt->m_dTableFuncArgs.Add(), (yyvsp[0]) );
		}
#line 3259 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 156:
#line 321 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToString ( pParser->m_pStmt->m_dTableFuncArgs.Add(), (yyvsp[0]) );
		}
#line 3267 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 160:
#line 333 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
		CSphVector<CSphQueryItem> & dItems = pParser->m_pQuery->m_dItems;
		if ( dItems.GetLength()!=1 || dItems[0].m_sExpr!="*" )
		{
			yyerror ( pParser, "outer select list must be a single star" );
			YYERROR;
		}
		dItems.Reset();
		pParser->ResetSelect();
	}
#line 3282 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 161:
#line 347 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToString ( pParser->m_pQuery->m_sOuterOrderBy, (yyvsp[0]) );
			pParser->m_pQuery->m_bHasOuter = true;
		}
#line 3291 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 163:
#line 356 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pQuery->m_iOuterLimit = (yyvsp[0]).m_iValue;
			pParser->m_pQuery->m_bHasOuter = true;
		}
#line 3300 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 164:
#line 361 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pQuery->m_iOuterOffset = (yyvsp[-2]).m_iValue;
			pParser->m_pQuery->m_iOuterLimit = (yyvsp[0]).m_iValue;
			pParser->m_pQuery->m_bHasOuter = true;
		}
#line 3310 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 165:
#line 378 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SELECT;
			pParser->ToString ( pParser->m_pQuery->m_sIndexes, (yyvsp[-7]) );
		}
#line 3319 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 168:
#line 390 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AddItem ( &(yyvsp[0]) ); }
#line 3325 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 171:
#line 396 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AliasLastItem ( &(yyvsp[0]) ); }
#line 3331 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 172:
#line 397 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AliasLastItem ( &(yyvsp[0]) ); }
#line 3337 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 173:
#line 401 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AddItem ( &(yyvsp[0]) ); }
#line 3343 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 174:
#line 402 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AddItem ( &(yyvsp[-1]), SPH_AGGR_AVG, &(yyvsp[-3]), &(yyvsp[0]) ); }
#line 3349 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 175:
#line 403 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AddItem ( &(yyvsp[-1]), SPH_AGGR_MAX, &(yyvsp[-3]), &(yyvsp[0]) ); }
#line 3355 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 176:
#line 404 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AddItem ( &(yyvsp[-1]), SPH_AGGR_MIN, &(yyvsp[-3]), &(yyvsp[0]) ); }
#line 3361 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 177:
#line 405 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AddItem ( &(yyvsp[-1]), SPH_AGGR_SUM, &(yyvsp[-3]), &(yyvsp[0]) ); }
#line 3367 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 178:
#line 406 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AddItem ( &(yyvsp[-1]), SPH_AGGR_CAT, &(yyvsp[-3]), &(yyvsp[0]) ); }
#line 3373 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 179:
#line 407 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->AddItem ( "count(*)", &(yyvsp[-3]), &(yyvsp[0]) ) ) YYERROR; }
#line 3379 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 180:
#line 408 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->AddItem ( "groupby()", &(yyvsp[-2]), &(yyvsp[0]) ) ) YYERROR; }
#line 3385 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 181:
#line 409 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->AddDistinct ( &(yyvsp[-1]), &(yyvsp[-4]), &(yyvsp[0]) ) ) YYERROR; }
#line 3391 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 183:
#line 414 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 3397 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 192:
#line 436 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->SetMatch((yyvsp[-1])) )
				YYERROR;
		}
#line 3406 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 193:
#line 443 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->SetOp ( (yyval) ); }
#line 3412 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 194:
#line 444 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->FilterAnd ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 3418 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 195:
#line 445 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->FilterOr ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 3424 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 196:
#line 446 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->FilterGroup ( (yyval), (yyvsp[-1]) ); }
#line 3430 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 197:
#line 452 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( (yyvsp[-2]) );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues.Add ( (yyvsp[0]).m_iValue );
		}
#line 3441 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 198:
#line 459 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( (yyvsp[-2]) );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues.Add ( (yyvsp[0]).m_iValue );
			pFilter->m_bExclude = true;
		}
#line 3453 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 199:
#line 467 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( (yyvsp[-4]) );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues = *(yyvsp[-1]).m_pValues;
			pFilter->m_dValues.Uniq();
		}
#line 3465 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 200:
#line 475 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( (yyvsp[-5]) );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues = *(yyvsp[-1]).m_pValues;
			pFilter->m_dValues.Uniq();
			pFilter->m_bExclude = true;
		}
#line 3478 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 201:
#line 484 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddStringListFilter ( (yyvsp[-4]), (yyvsp[-1]), STRLIST::IN_ ) )
				YYERROR;
		}
#line 3487 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 202:
#line 489 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddStringListFilter ( (yyvsp[-5]), (yyvsp[-1]), STRLIST::IN_, true ) )
				YYERROR;
		}
#line 3496 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 203:
#line 494 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddStringListFilter ( (yyvsp[-4]), (yyvsp[-1]), STRLIST::ANY ) )
				YYERROR;
		}
#line 3505 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 204:
#line 499 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
    		if ( !pParser->AddStringListFilter ( (yyvsp[-5]), (yyvsp[-1]), STRLIST::ANY, true ) )
    			YYERROR;
    	}
#line 3514 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 205:
#line 504 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddStringListFilter ( (yyvsp[-4]), (yyvsp[-1]), STRLIST::ALL ) )
				YYERROR;
		}
#line 3523 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 206:
#line 509 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddStringListFilter ( (yyvsp[-5]), (yyvsp[-1]), STRLIST::ALL, true ) )
				YYERROR;
		}
#line 3532 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 207:
#line 514 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddUservarFilter ( (yyvsp[-2]), (yyvsp[0]), false ) )
				YYERROR;
		}
#line 3541 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 208:
#line 519 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddUservarFilter ( (yyvsp[-3]), (yyvsp[0]), true ) )
				YYERROR;
		}
#line 3550 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 209:
#line 524 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddIntRangeFilter ( (yyvsp[-4]), (yyvsp[-2]).m_iValue, (yyvsp[0]).m_iValue, false ) )
				YYERROR;
		}
#line 3559 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 210:
#line 529 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddIntRangeFilter ( (yyvsp[-5]), (yyvsp[-3]).m_iValue, (yyvsp[-1]).m_iValue, true ) )
				YYERROR;
		}
#line 3568 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 211:
#line 534 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddIntFilterGreater ( (yyvsp[-2]), (yyvsp[0]).m_iValue, false ) )
				YYERROR;
		}
#line 3577 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 212:
#line 539 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddIntFilterLesser ( (yyvsp[-2]), (yyvsp[0]).m_iValue, false ) )
				YYERROR;
		}
#line 3586 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 213:
#line 544 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddIntFilterGreater ( (yyvsp[-2]), (yyvsp[0]).m_iValue, true ) )
				YYERROR;
		}
#line 3595 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 214:
#line 549 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddIntFilterLesser ( (yyvsp[-2]), (yyvsp[0]).m_iValue, true ) )
				YYERROR;
		}
#line 3604 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 215:
#line 554 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-2]), (yyvsp[0]).m_fValue, (yyvsp[0]).m_fValue, true ) )
				YYERROR;
		}
#line 3613 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 216:
#line 559 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-2]), (yyvsp[0]).m_fValue, (yyvsp[0]).m_fValue, true, true ) )
				YYERROR;
		}
#line 3622 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 217:
#line 564 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-4]), (yyvsp[-2]).m_fValue, (yyvsp[0]).m_fValue, true ) )
				YYERROR;
		}
#line 3631 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 218:
#line 569 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-4]), (yyvsp[-2]).m_iValue, (yyvsp[0]).m_fValue, true ) )
				YYERROR;
		}
#line 3640 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 219:
#line 574 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-4]), (yyvsp[-2]).m_fValue, (yyvsp[0]).m_iValue, true ) )
				YYERROR;
		}
#line 3649 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 220:
#line 579 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-2]), (yyvsp[0]).m_fValue, FLT_MAX, false ) )
				YYERROR;
		}
#line 3658 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 221:
#line 584 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-2]), -FLT_MAX, (yyvsp[0]).m_fValue, false ) )
				YYERROR;
		}
#line 3667 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 222:
#line 589 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-2]), (yyvsp[0]).m_fValue, FLT_MAX, true ) )
				YYERROR;
		}
#line 3676 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 223:
#line 594 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddFloatRangeFilter ( (yyvsp[-2]), -FLT_MAX, (yyvsp[0]).m_fValue, true ) )
				YYERROR;
		}
#line 3685 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 224:
#line 599 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddStringFilter ( (yyvsp[-2]), (yyvsp[0]), false ) )
				YYERROR;
		}
#line 3694 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 225:
#line 604 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddStringFilter ( (yyvsp[-2]), (yyvsp[0]), true ) )
				YYERROR;
		}
#line 3703 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 226:
#line 609 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddNullFilter ( (yyvsp[-2]), true ) )
				YYERROR;
		}
#line 3712 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 227:
#line 614 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddNullFilter ( (yyvsp[-3]), false ) )
				YYERROR;
		}
#line 3721 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 228:
#line 619 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( (yyvsp[-2]) );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues.Add ( (yyvsp[0]).m_iValue );
		}
#line 3732 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 229:
#line 626 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			CSphFilterSettings * pFilter = pParser->AddValuesFilter ( (yyvsp[-2]) );
			if ( !pFilter )
				YYERROR;
			pFilter->m_dValues.Add ( (yyvsp[0]).m_iValue );
			pFilter->m_bExclude = true;
		}
#line 3744 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 230:
#line 636 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			CSphFilterSettings * f = pParser->AddFilter ( (yyvsp[-2]), SPH_FILTER_VALUES );
			f->m_eMvaFunc = ( (yyvsp[-2]).m_iType==TOK_ALL ) ? SPH_MVAFUNC_ALL : SPH_MVAFUNC_ANY;
			f->m_dValues.Add ( (yyvsp[0]).m_iValue );
		}
#line 3754 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 231:
#line 642 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// tricky bit
			// any(tags!=val) is not equivalent to not(any(tags==val))
			// any(tags!=val) is instead equivalent to not(all(tags)==val)
			// thus, along with setting the exclude flag on, we also need to invert the function
			CSphFilterSettings * f = pParser->AddFilter ( (yyvsp[-2]), SPH_FILTER_VALUES );
			f->m_eMvaFunc = ( (yyvsp[-2]).m_iType==TOK_ALL ) ? SPH_MVAFUNC_ANY : SPH_MVAFUNC_ALL;
			f->m_bExclude = true;
			f->m_dValues.Add ( (yyvsp[0]).m_iValue );
		}
#line 3769 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 232:
#line 653 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			CSphFilterSettings * f = pParser->AddFilter ( (yyvsp[-4]), SPH_FILTER_VALUES );
			f->m_eMvaFunc = ( (yyvsp[-4]).m_iType==TOK_ALL ) ? SPH_MVAFUNC_ALL : SPH_MVAFUNC_ANY;
			f->m_dValues = *(yyvsp[-1]).m_pValues;
			f->m_dValues.Uniq();
		}
#line 3780 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 233:
#line 660 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// tricky bit with inversion again
			CSphFilterSettings * f = pParser->AddFilter ( (yyvsp[-5]), SPH_FILTER_VALUES );
			f->m_eMvaFunc = ( (yyvsp[-5]).m_iType==TOK_ALL ) ? SPH_MVAFUNC_ANY : SPH_MVAFUNC_ALL;
			f->m_bExclude = true;
			f->m_dValues = *(yyvsp[-1]).m_pValues;
			f->m_dValues.Uniq();
		}
#line 3793 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 234:
#line 669 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			AddMvaRange ( pParser, (yyvsp[-4]), (yyvsp[-2]).m_iValue, (yyvsp[0]).m_iValue );
		}
#line 3801 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 235:
#line 673 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// tricky bit with inversion again
			CSphFilterSettings * f = pParser->AddFilter ( (yyvsp[-5]), SPH_FILTER_RANGE );
			f->m_eMvaFunc = ( (yyvsp[-5]).m_iType==TOK_ALL ) ? SPH_MVAFUNC_ANY : SPH_MVAFUNC_ALL;
			f->m_bExclude = true;
			f->m_iMinValue = (yyvsp[-2]).m_iValue;
			f->m_iMaxValue = (yyvsp[0]).m_iValue;
		}
#line 3814 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 236:
#line 682 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			AddMvaRange ( pParser, (yyvsp[-2]), INT64_MIN, (yyvsp[0]).m_iValue-1 );
		}
#line 3822 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 237:
#line 686 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			AddMvaRange ( pParser, (yyvsp[-2]), (yyvsp[0]).m_iValue+1, INT64_MAX );
		}
#line 3830 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 238:
#line 690 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			AddMvaRange ( pParser, (yyvsp[-2]), INT64_MIN, (yyvsp[0]).m_iValue );
		}
#line 3838 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 239:
#line 694 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			AddMvaRange ( pParser, (yyvsp[-2]), (yyvsp[0]).m_iValue, INT64_MAX );
		}
#line 3846 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 240:
#line 698 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			TRACK_BOUNDS ( (yyval), (yyvsp[-5]), (yyvsp[0]) );
			CSphFilterSettings * pFilter = pParser->AddFilter ( (yyval), SPH_FILTER_EXPRESSION );
			if ( !pFilter )
				YYERROR;
		}
#line 3857 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 242:
#line 709 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->SetOldSyntax() )
				YYERROR;
		}
#line 3866 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 243:
#line 714 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_iType = SPHINXQL_TOK_COUNT;
			if ( !pParser->SetNewSyntax() )
				YYERROR;
		}
#line 3876 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 244:
#line 720 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_iType = SPHINXQL_TOK_GROUPBY;
			if ( !pParser->SetNewSyntax() )
				YYERROR;
		}
#line 3886 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 245:
#line 726 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_iType = SPHINXQL_TOK_WEIGHT;
			if ( !pParser->SetNewSyntax() )
				YYERROR;
		}
#line 3896 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 246:
#line 732 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_iType = SPHINXQL_TOK_ID;
			if ( !pParser->SetNewSyntax() )
				YYERROR;
		}
#line 3906 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 248:
#line 738 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 3912 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 249:
#line 739 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 3918 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 250:
#line 740 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 3924 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 252:
#line 745 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); (yyval).m_iType = TOK_ANY; }
#line 3930 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 253:
#line 746 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); (yyval).m_iType = TOK_ALL; }
#line 3936 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 254:
#line 750 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_CONST_INT; (yyval).m_iValue = (yyvsp[0]).m_iValue; }
#line 3942 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 255:
#line 752 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_iType = TOK_CONST_INT;
			if ( (uint64_t)(yyvsp[0]).m_iValue > (uint64_t)LLONG_MAX )
				(yyval).m_iValue = LLONG_MIN;
			else
				(yyval).m_iValue = -(yyvsp[0]).m_iValue;
		}
#line 3954 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 256:
#line 762 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_CONST_FLOAT; (yyval).m_fValue = (yyvsp[0]).m_fValue; }
#line 3960 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 257:
#line 763 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_CONST_FLOAT; (yyval).m_fValue = -(yyvsp[0]).m_fValue; }
#line 3966 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 258:
#line 764 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_CONST_FLOAT; (yyval).m_fValue = (yyvsp[0]).m_fValue; }
#line 3972 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 259:
#line 769 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			assert ( !(yyval).m_pValues );
			(yyval).m_pValues = new RefcountedVector_c<SphAttr_t> ();
			(yyval).m_pValues->Add ( (yyvsp[0]).m_iValue ); 
		}
#line 3982 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 260:
#line 775 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_pValues->Add ( (yyvsp[0]).m_iValue );
		}
#line 3990 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 261:
#line 782 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			assert ( !(yyval).m_pValues );
			(yyval).m_pValues = new RefcountedVector_c<SphAttr_t> ();
			(yyval).m_pValues->Add ( (yyvsp[0]).m_iValue );
		}
#line 4000 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 262:
#line 788 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_pValues->Add ( (yyvsp[0]).m_iValue );
		}
#line 4008 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 266:
#line 801 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetGroupbyLimit ( (yyvsp[0]).m_iValue );
		}
#line 4016 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 267:
#line 808 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->AddGroupBy ( (yyvsp[0]) );
		}
#line 4024 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 268:
#line 812 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->AddGroupBy ( (yyvsp[0]) );
		}
#line 4032 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 270:
#line 820 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->AddHaving();
		}
#line 4040 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 273:
#line 832 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( pParser->m_pQuery->m_sGroupBy.IsEmpty() )
			{
				yyerror ( pParser, "you must specify GROUP BY element in order to use WITHIN GROUP ORDER BY clause" );
				YYERROR;
			}
			pParser->ToString ( pParser->m_pQuery->m_sSortBy, (yyvsp[0]) );
		}
#line 4053 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 276:
#line 849 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToString ( pParser->m_pQuery->m_sOrderBy, (yyvsp[0]) );
		}
#line 4061 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 277:
#line 853 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pQuery->m_sOrderBy = "@random";
		}
#line 4069 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 279:
#line 860 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4075 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 281:
#line 865 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-1]), (yyvsp[0]) ); }
#line 4081 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 282:
#line 866 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-1]), (yyvsp[0]) ); }
#line 4087 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 285:
#line 876 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetLimit ( 0, (yyvsp[0]).m_iValue );
		}
#line 4095 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 286:
#line 880 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetLimit ( (yyvsp[-2]).m_iValue, (yyvsp[0]).m_iValue );
		}
#line 4103 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 292:
#line 901 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddOption ( (yyvsp[0]) ) )
				YYERROR;
		}
#line 4112 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 293:
#line 906 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddOption ( (yyvsp[-2]), (yyvsp[0]) ) )
				YYERROR;
		}
#line 4121 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 294:
#line 911 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddOption ( (yyvsp[-2]), (yyvsp[0]) ) )
				YYERROR;
		}
#line 4130 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 295:
#line 916 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddOption ( (yyvsp[-4]), pParser->GetNamedVec ( (yyvsp[-1]).m_iValue ) ) )
				YYERROR;
			pParser->FreeNamedVec ( (yyvsp[-1]).m_iValue );
		}
#line 4140 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 296:
#line 922 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddOption ( (yyvsp[-5]), (yyvsp[-3]), (yyvsp[-1]) ) )
				YYERROR;
		}
#line 4149 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 297:
#line 927 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->AddOption ( (yyvsp[-2]), (yyvsp[0]) ) )
				YYERROR;
		}
#line 4158 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 298:
#line 935 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_iValue = pParser->AllocNamedVec ();
			pParser->AddConst ( (yyval).m_iValue, (yyvsp[0]) );
		}
#line 4167 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 299:
#line 940 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->AddConst( (yyval).m_iValue, (yyvsp[0]) );
		}
#line 4175 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 300:
#line 947 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval) = (yyvsp[-2]);
			(yyval).m_iValue = (yyvsp[0]).m_iValue;
		}
#line 4184 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 302:
#line 957 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->SetOldSyntax() ) YYERROR; }
#line 4190 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 303:
#line 958 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->SetNewSyntax() ) YYERROR; }
#line 4196 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 308:
#line 963 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-1]), (yyvsp[0]) ); }
#line 4202 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 309:
#line 964 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-1]), (yyvsp[0]) ); }
#line 4208 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 310:
#line 966 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4214 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 311:
#line 967 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4220 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 312:
#line 968 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4226 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 313:
#line 969 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4232 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 314:
#line 970 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4238 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 315:
#line 971 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4244 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 316:
#line 972 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4250 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 317:
#line 973 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4256 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 318:
#line 974 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4262 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 319:
#line 975 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4268 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 320:
#line 976 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4274 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 321:
#line 977 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4280 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 322:
#line 978 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4286 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 323:
#line 979 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4292 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 324:
#line 980 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4298 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 325:
#line 981 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4304 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 326:
#line 982 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4310 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 327:
#line 983 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4316 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 328:
#line 984 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4322 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 332:
#line 988 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4328 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 333:
#line 989 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4334 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 334:
#line 993 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4340 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 335:
#line 994 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4346 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 336:
#line 995 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-4]), (yyvsp[0]) ); }
#line 4352 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 337:
#line 996 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4358 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 338:
#line 997 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4364 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 339:
#line 998 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4370 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 340:
#line 999 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4376 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 341:
#line 1000 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4382 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 342:
#line 1001 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-5]), (yyvsp[0]) ); }
#line 4388 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 343:
#line 1002 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-5]), (yyvsp[0]) ); }
#line 4394 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 344:
#line 1003 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4400 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 345:
#line 1004 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-7]), (yyvsp[0]) ); }
#line 4406 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 346:
#line 1005 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-13]), (yyvsp[0]) ); }
#line 4412 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 347:
#line 1006 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4418 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 348:
#line 1007 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4424 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 349:
#line 1008 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-3]), (yyvsp[0]) ); }
#line 4430 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 357:
#line 1028 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 4436 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 358:
#line 1029 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-4]), (yyvsp[0]) ); }
#line 4442 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 365:
#line 1050 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->ToStringUnescape ( pParser->m_pStmt->m_sStringParam, (yyvsp[0]) ); }
#line 4448 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 366:
#line 1054 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_WARNINGS; }
#line 4454 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 367:
#line 1055 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_STATUS; }
#line 4460 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 368:
#line 1056 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_META; }
#line 4466 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 369:
#line 1057 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_AGENT_STATUS; }
#line 4472 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 370:
#line 1058 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_PROFILE; }
#line 4478 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 371:
#line 1059 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_PLAN; }
#line 4484 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 372:
#line 1060 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_PLUGINS; }
#line 4490 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 373:
#line 1061 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_THREADS; }
#line 4496 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 374:
#line 1063 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_AGENT_STATUS;
			pParser->ToStringUnescape ( pParser->m_pStmt->m_sIndex, (yyvsp[-2]) );
		}
#line 4505 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 375:
#line 1068 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_AGENT_STATUS;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-2]) );
		}
#line 4514 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 376:
#line 1073 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_INDEX_STATUS;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-1]) );
		}
#line 4523 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 377:
#line 1078 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_INDEX_SETTINGS;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-2]) );
		}
#line 4532 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 378:
#line 1083 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_INDEX_SETTINGS;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-2]) );
			pParser->m_pStmt->m_iIntParam = int((yyvsp[-1]).m_fValue*10);
		}
#line 4542 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 379:
#line 1089 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_INDEX_STATUS;
			pParser->m_pStmt->m_sIndex = pParser->m_pStmt->m_sStringParam;
		}
#line 4551 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 383:
#line 1103 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_iIntParam = (yyvsp[0]).m_iValue;
		}
#line 4559 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 384:
#line 1111 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-2]), SET_LOCAL );
			pParser->m_pStmt->m_iSetValue = (yyvsp[0]).m_iValue;
		}
#line 4568 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 385:
#line 1116 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-2]), SET_LOCAL );
			pParser->ToString ( pParser->m_pStmt->m_sSetValue, (yyvsp[0]) );
		}
#line 4577 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 386:
#line 1121 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-2]), SET_LOCAL );
//			pParser->m_pStmt->m_bSetNull = true;
		}
#line 4586 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 387:
#line 1125 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_DUMMY; }
#line 4592 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 388:
#line 1126 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_DUMMY; }
#line 4598 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 389:
#line 1127 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_DUMMY; }
#line 4604 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 390:
#line 1128 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_DUMMY; }
#line 4610 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 391:
#line 1133 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-4]), SET_GLOBAL_UVAR );
			pParser->m_pStmt->m_dSetValues = *(yyvsp[-1]).m_pValues;
		}
#line 4619 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 392:
#line 1138 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-2]), SET_GLOBAL_SVAR );
			pParser->ToString ( pParser->m_pStmt->m_sSetValue, (yyvsp[0]) ).Unquote();
		}
#line 4628 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 393:
#line 1143 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-2]), SET_GLOBAL_SVAR );
			pParser->m_pStmt->m_iSetValue = (yyvsp[0]).m_iValue;
		}
#line 4637 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 394:
#line 1148 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-4]), SET_INDEX_UVAR );
			pParser->m_pStmt->m_dSetValues = *(yyvsp[-1]).m_pValues;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-6]) );
		}
#line 4647 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 395:
#line 1154 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-2]), SET_CLUSTER_UVAR );
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-4]) );
			pParser->ToString ( pParser->m_pStmt->m_sSetName, (yyvsp[-2]) ).Unquote();
			pParser->ToString ( pParser->m_pStmt->m_sSetValue, (yyvsp[0]) ).Unquote();
		}
#line 4658 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 396:
#line 1161 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->SetStatement ( (yyvsp[-2]), SET_CLUSTER_UVAR );
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-4]) );
			pParser->ToString ( pParser->m_pStmt->m_sSetName, (yyvsp[-2]) ).Unquote();
			pParser->m_pStmt->m_sSetValue.SetSprintf ( INT64_FMT, (yyvsp[0]).m_iValue );
		}
#line 4669 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 399:
#line 1175 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = 1; }
#line 4675 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 400:
#line 1176 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = 0; }
#line 4681 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 401:
#line 1178 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_iValue = (yyvsp[0]).m_iValue;
			if ( (yyval).m_iValue!=0 && (yyval).m_iValue!=1 )
			{
				yyerror ( pParser, "only 0 and 1 could be used as boolean values" );
				YYERROR;
			}
		}
#line 4694 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 409:
#line 1205 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_COMMIT; }
#line 4700 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 410:
#line 1206 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_ROLLBACK; }
#line 4706 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 411:
#line 1207 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_BEGIN; }
#line 4712 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 414:
#line 1219 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// everything else is pushed directly into parser within the rules
			pParser->SetIndex ( (yyvsp[-4]) );
		}
#line 4721 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 415:
#line 1226 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_INSERT; }
#line 4727 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 416:
#line 1227 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_REPLACE; }
#line 4733 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 421:
#line 1241 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->AddSchemaItem ( &(yyvsp[0]) ) ) { yyerror ( pParser, "unknown field" ); YYERROR; } }
#line 4739 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 422:
#line 1242 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->AddSchemaItem ( &(yyvsp[0]) ) ) { yyerror ( pParser, "unknown field" ); YYERROR; } }
#line 4745 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 425:
#line 1251 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->m_pStmt->CheckInsertIntegrity() ) { yyerror ( pParser, "wrong number of values here" ); YYERROR; } }
#line 4751 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 426:
#line 1255 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { AddInsval ( pParser, pParser->m_pStmt->m_dInsertValues, (yyvsp[0]) ); }
#line 4757 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 427:
#line 1256 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { AddInsval ( pParser, pParser->m_pStmt->m_dInsertValues, (yyvsp[0]) ); }
#line 4763 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 428:
#line 1260 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_CONST_INT; (yyval).m_iValue = (yyvsp[0]).m_iValue; }
#line 4769 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 429:
#line 1261 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_CONST_FLOAT; (yyval).m_fValue = (yyvsp[0]).m_fValue; }
#line 4775 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 430:
#line 1262 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_QUOTED_STRING; (yyval).m_iStart = (yyvsp[0]).m_iStart; (yyval).m_iEnd = (yyvsp[0]).m_iEnd; }
#line 4781 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 431:
#line 1263 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_CONST_MVA; (yyval).m_pValues = (yyvsp[-1]).m_pValues; }
#line 4787 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 432:
#line 1264 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iType = TOK_CONST_MVA; }
#line 4793 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 437:
#line 1277 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { if ( !pParser->AddInsertOption ( (yyvsp[-2]), (yyvsp[0]) ) ) YYERROR; }
#line 4799 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 438:
#line 1284 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
		if ( !pParser->DeleteStatement ( &(yyvsp[-1]) ) )
			YYERROR;
	}
#line 4808 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 439:
#line 1294 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_CALL;
			pParser->ToString ( pParser->m_pStmt->m_sCallProc, (yyvsp[-4]) );
		}
#line 4817 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 440:
#line 1302 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			AddInsval ( pParser, pParser->m_pStmt->m_dInsertValues, (yyvsp[0]) );
		}
#line 4825 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 441:
#line 1306 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			AddInsval ( pParser, pParser->m_pStmt->m_dInsertValues, (yyvsp[0]) );
		}
#line 4833 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 443:
#line 1314 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			(yyval).m_iType = TOK_CONST_STRINGS;
		}
#line 4841 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 444:
#line 1321 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// FIXME? for now, one such array per CALL statement, tops
			if ( pParser->m_pStmt->m_dCallStrings.GetLength() )
			{
				yyerror ( pParser, "unexpected constant string list" );
				YYERROR;
			}
			pParser->ToStringUnescape ( pParser->m_pStmt->m_dCallStrings.Add(), (yyvsp[0]) );
		}
#line 4855 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 445:
#line 1331 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToStringUnescape ( pParser->m_pStmt->m_dCallStrings.Add(), (yyvsp[0]) );
		}
#line 4863 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 448:
#line 1343 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			assert ( pParser->m_pStmt->m_dCallOptNames.GetLength()==1 );
			assert ( pParser->m_pStmt->m_dCallOptValues.GetLength()==1 );
		}
#line 4872 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 450:
#line 1352 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToString ( pParser->m_pStmt->m_dCallOptNames.Add(), (yyvsp[0]) );
			AddInsval ( pParser, pParser->m_pStmt->m_dCallOptValues, (yyvsp[-2]) );
		}
#line 4881 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 455:
#line 1372 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_DESCRIBE;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-2]) );
		}
#line 4890 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 457:
#line 1381 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_iIntParam = 42; // just a flag that 'TOK_TABLE' is in use
		}
#line 4898 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 460:
#line 1393 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_TABLES; }
#line 4904 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 461:
#line 1397 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->m_pStmt->m_eStmt = STMT_SHOW_DATABASES; }
#line 4910 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 462:
#line 1404 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			if ( !pParser->UpdateStatement ( &(yyvsp[-4]) ) )
				YYERROR;
		}
#line 4919 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 465:
#line 1417 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// it is performance-critical to forcibly inline this
			pParser->m_pStmt->m_tUpdate.m_dPool.Add ( (DWORD)(yyvsp[0]).m_iValue );
			DWORD uHi = (DWORD)( (yyvsp[0]).m_iValue>>32 );
			if ( uHi )
			{
				pParser->m_pStmt->m_tUpdate.m_dPool.Add ( uHi );
				pParser->AddUpdatedAttr ( (yyvsp[-2]), SPH_ATTR_BIGINT );
			} else
			{
				pParser->AddUpdatedAttr ( (yyvsp[-2]), SPH_ATTR_INTEGER );
			}
		}
#line 4937 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 466:
#line 1431 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// it is performance-critical to forcibly inline this
			pParser->m_pStmt->m_tUpdate.m_dPool.Add ( sphF2DW ( (yyvsp[0]).m_fValue ) );
			pParser->AddUpdatedAttr ( (yyvsp[-2]), SPH_ATTR_FLOAT );
		}
#line 4947 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 467:
#line 1437 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->UpdateMVAAttr ( (yyvsp[-4]), (yyvsp[-1]) );
		}
#line 4955 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 468:
#line 1441 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlNode_t tNoValues;
			pParser->UpdateMVAAttr ( (yyvsp[-3]), tNoValues );
		}
#line 4964 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 469:
#line 1446 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// it is performance-critical to forcibly inline this
			pParser->m_pStmt->m_tUpdate.m_dPool.Add ( (DWORD)(yyvsp[0]).m_iValue );
			DWORD uHi = (DWORD)( (yyvsp[0]).m_iValue>>32 );
			if ( uHi )
			{
				pParser->m_pStmt->m_tUpdate.m_dPool.Add ( uHi );
				pParser->AddUpdatedAttr ( (yyvsp[-2]), SPH_ATTR_BIGINT );
			} else
			{
				pParser->AddUpdatedAttr ( (yyvsp[-2]), SPH_ATTR_INTEGER );
			}
		}
#line 4982 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 470:
#line 1460 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			// it is performance-critical to forcibly inline this
			pParser->m_pStmt->m_tUpdate.m_dPool.Add ( sphF2DW ( (yyvsp[0]).m_fValue ) );
			pParser->AddUpdatedAttr ( (yyvsp[-2]), SPH_ATTR_FLOAT );
		}
#line 4992 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 471:
#line 1470 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_INTEGER; }
#line 4998 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 472:
#line 1471 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_BIGINT; }
#line 5004 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 473:
#line 1472 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_FLOAT; }
#line 5010 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 474:
#line 1473 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_BOOL; }
#line 5016 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 475:
#line 1474 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_UINT32SET; }
#line 5022 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 476:
#line 1475 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_INT64SET; }
#line 5028 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 477:
#line 1476 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_JSON; }
#line 5034 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 478:
#line 1477 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_STRING; }
#line 5040 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 479:
#line 1478 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_INTEGER; }
#line 5046 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 480:
#line 1483 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_ALTER_ADD;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[-4]) );
			pParser->ToString ( tStmt.m_sAlterAttr, (yyvsp[-1]) );
			tStmt.m_eAlterColType = (ESphAttr)(yyvsp[0]).m_iValue;
		}
#line 5058 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 481:
#line 1491 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_ALTER_DROP;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[-3]) );
			pParser->ToString ( tStmt.m_sAlterAttr, (yyvsp[0]) );
		}
#line 5069 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 482:
#line 1498 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_ALTER_RECONFIGURE;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[-1]) );
		}
#line 5079 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 483:
#line 1504 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_CLUSTER_ALTER_ADD;
			pParser->ToString ( tStmt.m_sCluster, (yyvsp[-2]) );
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[0]) );
		}
#line 5090 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 484:
#line 1511 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_CLUSTER_ALTER_DROP;
			pParser->ToString ( tStmt.m_sCluster, (yyvsp[-2]) );
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[0]) );
		}
#line 5101 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 485:
#line 1523 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_VARIABLES;
		}
#line 5109 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 486:
#line 1527 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_VARIABLES;
			pParser->ToStringUnescape ( pParser->m_pStmt->m_sStringParam, (yyvsp[0]) );
		}
#line 5118 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 493:
#line 1552 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_COLLATION;
		}
#line 5126 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 494:
#line 1559 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SHOW_CHARACTER_SET;
		}
#line 5134 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 495:
#line 1566 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_DUMMY;
		}
#line 5142 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 503:
#line 1587 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_CREATE_FUNCTION;
			pParser->ToString ( tStmt.m_sUdfName, (yyvsp[-4]) );
			pParser->ToStringUnescape ( tStmt.m_sUdfLib, (yyvsp[0]) );
			tStmt.m_eUdfType = (ESphAttr) (yyvsp[-2]).m_iValue;
		}
#line 5154 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 504:
#line 1597 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_INTEGER; }
#line 5160 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 505:
#line 1598 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_BIGINT; }
#line 5166 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 506:
#line 1599 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_FLOAT; }
#line 5172 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 507:
#line 1600 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_STRINGPTR; }
#line 5178 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 508:
#line 1601 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval).m_iValue = SPH_ATTR_INTEGER; }
#line 5184 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 509:
#line 1607 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_DROP_FUNCTION;
			pParser->ToString ( tStmt.m_sUdfName, (yyvsp[0]) );
		}
#line 5194 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 510:
#line 1618 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_ATTACH_INDEX;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[-4]) );
			pParser->ToString ( tStmt.m_sStringParam, (yyvsp[-1]) );
		}
#line 5205 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 512:
#line 1629 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_iIntParam = 1;
		}
#line 5213 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 513:
#line 1638 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_RTINDEX;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[0]) );
		}
#line 5223 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 514:
#line 1647 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_RAMCHUNK;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[0]) );
		}
#line 5233 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 515:
#line 1656 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_INDEX;
		}
#line 5242 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 516:
#line 1664 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_HOSTNAMES;
		}
#line 5251 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 517:
#line 1672 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_FLUSH_LOGS;
		}
#line 5260 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 518:
#line 1682 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SELECT_SYSVAR;
			pParser->ToString ( pParser->m_pStmt->m_tQuery.m_sQuery, (yyvsp[-1]) );
		}
#line 5269 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 522:
#line 1698 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { pParser->AddItem ( &(yyvsp[0]) ); }
#line 5275 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 523:
#line 1703 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_SELECT_DUAL;
			pParser->ToString ( pParser->m_pStmt->m_tQuery.m_sQuery, (yyvsp[0]) );
		}
#line 5284 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 524:
#line 1713 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_TRUNCATE_RTINDEX;
			pParser->SetIndex ( (yyvsp[-1]) );
		}
#line 5294 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 526:
#line 1723 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_iIntParam = 1;
		}
#line 5302 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 527:
#line 1732 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_OPTIMIZE_INDEX;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[-1]) );
		}
#line 5312 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 528:
#line 1743 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & s = *pParser->m_pStmt;
			s.m_eStmt = STMT_CREATE_PLUGIN;
			pParser->ToString ( s.m_sUdfName, (yyvsp[-4]) );
			pParser->ToStringUnescape ( s.m_sStringParam, (yyvsp[-2]) );
			pParser->ToStringUnescape ( s.m_sUdfLib, (yyvsp[0]) );
		}
#line 5324 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 529:
#line 1754 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & s = *pParser->m_pStmt;
			s.m_eStmt = STMT_DROP_PLUGIN;
			pParser->ToString ( s.m_sUdfName, (yyvsp[-2]) );
			pParser->ToStringUnescape ( s.m_sStringParam, (yyvsp[0]) );
		}
#line 5335 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 530:
#line 1764 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & s = *pParser->m_pStmt;
			s.m_eStmt = STMT_RELOAD_PLUGINS;
			pParser->ToStringUnescape ( s.m_sUdfLib, (yyvsp[0]) );
		}
#line 5345 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 533:
#line 1779 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); (yyval).m_iEnd = (yyvsp[0]).m_iEnd; }
#line 5351 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 535:
#line 1783 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-1]); (yyval).m_iEnd = (yyvsp[0]).m_iEnd; }
#line 5357 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 536:
#line 1787 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); (yyval).m_iEnd = (yyvsp[0]).m_iEnd; }
#line 5363 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 537:
#line 1788 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[0]); (yyval).m_iEnd = (yyvsp[0]).m_iEnd; }
#line 5369 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 538:
#line 1789 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyval).m_iEnd = (yyvsp[0]).m_iEnd; }
#line 5375 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 539:
#line 1790 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { (yyval) = (yyvsp[-2]); (yyval).m_iEnd = (yyvsp[0]).m_iEnd; }
#line 5381 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 540:
#line 1794 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 5387 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 541:
#line 1795 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    { TRACK_BOUNDS ( (yyval), (yyvsp[-2]), (yyvsp[0]) ); }
#line 5393 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 545:
#line 1811 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pQuery->m_sFacetBy = pParser->m_pQuery->m_sGroupBy;
			pParser->m_pQuery->m_sGroupBy = "";
			pParser->AddCount ();
		}
#line 5403 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 547:
#line 1824 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->AddItem ( &(yyvsp[0]) );
			pParser->AddGroupBy ( (yyvsp[0]) );
		}
#line 5412 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 550:
#line 1837 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_FACET;
			if ( pParser->m_pQuery->m_sFacetBy.IsEmpty() )
			{
				pParser->m_pQuery->m_sFacetBy = pParser->m_pQuery->m_sGroupBy;
				pParser->AddCount ();
			}
		}
#line 5425 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 552:
#line 1850 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToStringUnescape ( pParser->m_pStmt->m_sStringParam, (yyvsp[0]) );
		}
#line 5433 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 553:
#line 1857 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->m_pStmt->m_eStmt = STMT_RELOAD_INDEX;
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-1]));
		}
#line 5442 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 554:
#line 1865 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_RELOAD_INDEXES;
		}
#line 5451 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 555:
#line 1873 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_SYSFILTERS;
		}
#line 5460 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 556:
#line 1881 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
            pParser->m_pStmt->m_eStmt = STMT_DEBUG;
        }
#line 5468 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 558:
#line 1888 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[0]) );
		}
#line 5476 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 559:
#line 1892 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-1]) );
			pParser->ToString ( pParser->m_pStmt->m_sStringParam, (yyvsp[0]) );
		}
#line 5485 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 560:
#line 1897 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			pParser->ToString ( pParser->m_pStmt->m_sIndex, (yyvsp[-1]) );
			pParser->m_pStmt->m_iIntParam = (yyvsp[0]).m_iValue;
		}
#line 5494 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 561:
#line 1904 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_JOIN_CLUSTER;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[-1]) );
		}
#line 5504 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 564:
#line 1918 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_CLUSTER_CREATE;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[-1]) );
		}
#line 5514 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;

  case 565:
#line 1927 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1646  */
    {
			SqlStmt_t & tStmt = *pParser->m_pStmt;
			tStmt.m_eStmt = STMT_CLUSTER_DELETE;
			pParser->ToString ( tStmt.m_sIndex, (yyvsp[0]) );
		}
#line 5524 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
    break;


#line 5528 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/build/config/bissphinxql.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (pParser, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (pParser, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pParser);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, pParser);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (pParser, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pParser);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, pParser);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1934 "/home/gitlab-runner/builds/ae04cf72/0/manticoresearch/dev/src/sphinxql.y" /* yacc.c:1906  */


#if USE_WINDOWS
#pragma warning(pop)
#endif
